unit UMain;

// Jurassic Editor
// By Uberto Barbini
// uberto@usa.net
// for Brain's Den
// Summer 1997

// Code tidied by Dominique Louis November 1999
// AND Also Code tidied by John Lohmeyer November 2000

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ExtCtrls, unit3, StdCtrls, ExtDlgs, ComCtrls, Buttons, DirectX, DXDraws,
  DXClass;

type
  TSState = set of ( ssShift, ssCtrl );
  TMainform = class( TForm )
    MainMenu1 : TMainMenu;
    file1 : TMenuItem;
    Help1 : TMenuItem;
    About1 : TMenuItem;
    NewProject1 : TMenuItem;
    mnuOpenProject: TMenuItem;
    mnuSaveProject: TMenuItem;
    N1 : TMenuItem;
    Exit1 : TMenuItem;
    Windows1 : TMenuItem;
    Tiles1 : TMenuItem;
    Sprites1 : TMenuItem;
    SaveDialog1 : TSaveDialog;
    OpenDialog : TOpenDialog;
    View1 : TMenuItem;
    N1stview1 : TMenuItem;
    N2ndView1 : TMenuItem;
    N3rdView1 : TMenuItem;
    N4thView1 : TMenuItem;
    OpenTileFile1 : TMenuItem;
    N2 : TMenuItem;
    N4 : TMenuItem;
    OpenPictureDialog : TOpenPictureDialog;
    SpritePosition1 : TMenuItem;
    N5 : TMenuItem;
    Op1 : TMenuItem;
    StatusBar1 : TStatusBar;
    N6 : TMenuItem;
    mnuCreateGlobalMap: TMenuItem;
    Panel1: TPanel;
    btnOpen: TSpeedButton;
    btnSave: TSpeedButton;
    btnNew: TSpeedButton;
    Bevel1: TBevel;
    Panel13: TPanel;
    pmImage: TPopupMenu;
    pgEditor: TPageControl;
    TabSheet1: TTabSheet;
    Panel5: TPanel;
    plInfo: TPanel;
    Panel6: TPanel;
    Panel7: TPanel;
    Panel11: TPanel;
    TabSheet2: TTabSheet;
    Panel10: TPanel;
    btnTileUp: TSpeedButton;
    btnTileDown: TSpeedButton;
    btnTileFill: TSpeedButton;
    Panel12: TPanel;
    ScrollBox2: TScrollBox;
    ImageTiled: TImage;
    TabSheet_Sprites: TTabSheet;
    Panel14: TPanel;
    ImageTile: TImage;
    btnUndo: TSpeedButton;
    Panel15: TPanel;
    ShapeMap: TShape;
    Shape2: TShape;
    RaiseitUp1: TMenuItem;
    RaiseitDown1: TMenuItem;
    N7: TMenuItem;
    Panel16: TPanel;
    ImageSelTile: TImage;
    cbDebugTiles: TCheckBox;
    cbShowSprites: TCheckBox;
    lblType: TLabel;
    lblPlane: TLabel;
    Bevel2: TBevel;
    btn1st: TSpeedButton;
    btn2nd: TSpeedButton;
    btn3rd: TSpeedButton;
    btn4th: TSpeedButton;
    Bevel3: TBevel;
    btnTileEdit: TSpeedButton;
    btnSpriteEdit: TSpeedButton;
    btnSpritePos: TSpeedButton;
    lvSprites: TListView;
    lvSpritesPos: TListView;
    PanelSpriteInfo1: TPanel;
    PanelSpriteInfo2: TPanel;
    PanelSpriteInfo3: TPanel;
    PanelSpritePrev: TPanel;
    CurrSpriteImage: TImage;
    Panel18: TPanel;
    mnuOptions: TMenuItem;
    btnPreview: TSpeedButton;
    Bevel4: TBevel;
    Bevel5: TBevel;
    btnOptions: TSpeedButton;
    btnNewSprite: TSpeedButton;
    cbPreviewTile: TCheckBox;
    Panel2: TPanel;
    ImageBackup: TImage;
    SpeedButton1: TSpeedButton;
    btnEditSprite: TSpeedButton;
    btnEditTile: TSpeedButton;
    Bevel6: TBevel;
    Edit1: TMenuItem;
    mnuEditTile: TMenuItem;
    mnuEditSprite: TMenuItem;
    N3: TMenuItem;
    mnuUndo: TMenuItem;
    mnuDebug: TMenuItem;
    cbDebugSprites: TCheckBox;
    btnRefresh: TSpeedButton;
    btnSpriteRight: TSpeedButton;
    btnSpriteLeft: TSpeedButton;
    btnSpriteDown: TSpeedButton;
    btnSpriteUp: TSpeedButton;
    DXDraw: TDXDraw;
    DXTimer1: TDXTimer;
    btnPriorityPlus: TSpeedButton;
    btnPriorityMin: TSpeedButton;
    mnuSaveMap: TMenuItem;
    btnSprProperties: TSpeedButton;
    UpDown1: TUpDown;
    UpDown2: TUpDown;
    UpDownGamma: TUpDown;
    procedure Exit1Click( Sender : TObject );
    procedure FormCreate( Sender : TObject );
    procedure About1Click( Sender : TObject );
    procedure mnuTilesClick( Sender : TObject );
    procedure NewProject1Click( Sender : TObject );
    procedure mnuOpenProjectClick( Sender : TObject );
    procedure mnuSaveAsProjectClick( Sender : TObject );
    procedure Up1Click( Sender : TObject );
    procedure Down1Click( Sender : TObject );
    procedure Left1Click( Sender : TObject );
    procedure Right1Click( Sender : TObject );
    procedure OpenTileFile1Click( Sender : TObject );
    procedure Raise1Click( Sender : TObject );
    procedure Lower1Click( Sender : TObject );
    procedure UP2Click( Sender : TObject );
    procedure UpRight1Click( Sender : TObject );
    procedure DownLeft1Click( Sender : TObject );
    procedure DownRight1Click( Sender : TObject );
    procedure FormKeyDown( Sender : TObject; var Key : Word;
      Shift : TShiftState );
    procedure N3Click( Sender : TObject );
    procedure mnuSpritesClick( Sender : TObject );
    procedure N1stview1Click( Sender : TObject );
    procedure N2ndView1Click( Sender : TObject );
    procedure N3rdView1Click( Sender : TObject );
    procedure N4thView1Click( Sender : TObject );
    procedure Op1Click( Sender : TObject );
    procedure mnuCreateGlobalMapClick( Sender : TObject );
    procedure ImageTiledMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ImageTiledMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btnTileUpClick(Sender: TObject);
    procedure btnTileDownClick(Sender: TObject);
    procedure btnTileFillClick(Sender: TObject);
    procedure ImageMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ShapeMapMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btnUndoClick(Sender: TObject);
    procedure ScrollBarVScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure cbRefreshClick(Sender: TObject);
    procedure ShapeMapMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure mnuOptionsClick(Sender: TObject);
    procedure lvSpritesSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure btnPreviewClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure btnEditModeClick(Sender: TObject);
    procedure mnuDebugClick(Sender: TObject);
    procedure btnRefreshClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure btnNewSpriteClick(Sender: TObject);
    procedure lvSpritesPosSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure btnSpritePosClick(Sender: TObject);
    procedure DXTimer1Timer(Sender: TObject; LagCount: Integer);
    procedure DXDrawInitializeSurface(Sender: TObject);
    procedure DXDrawFinalizeSurface(Sender: TObject);
    procedure btnPriorityPlusClick(Sender: TObject);
    procedure btnPriorityMinClick(Sender: TObject);
    procedure mnuSaveMapClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure UpDown2Click(Sender: TObject; Button: TUDBtnType);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure btnSprPropertiesClick(Sender: TObject);
    procedure UpDownGammaClick(Sender: TObject; Button: TUDBtnType);
  private
  { Private declarations }
    LeftMouseTile : boolean;
  public
  { Public declarations }
    cam, PosX, PosY, poX, poY : integer;
    fix_px, fix_py, fix_tx, fix_ty, fix_tw, fix_th, fix_tile : integer; // global pos for moving cursor
    LastX, LastY  : integer; // Last position of the mouse
    LastTX, LastTY, LastTW, LastTH, LastKey : integer;
    moved : boolean;         // Did I move the mouse?
    selected_SpriteData : TSpriteData;
    undo_px, undo_py, undo_tile : integer;  // undo buffer
    selectedTile : integer;     // The tile selected
    shfstate : TSState;
    prjFileName, CurrentPath : string;
    FSurface: TDirectDrawSurface;
    TileSurface: TDirectDrawSurface;
    FDefaultGammaRamp: TDDGammaRamp;        // Default gamma
    procedure SaveToFile( name : string);
    procedure SelectNrTile( tile : integer );
    procedure ShowTerrain;
    procedure MoveScaleMap;
    procedure DessignScaleMap;
    procedure DrawTile;         // Draws a simple tile on the map
    procedure DrawSprite;
    procedure TileMouseMove(X,  Y: Integer); // Moves the tile editor
    procedure ShowSpritesinWindow;
    procedure ShowSpritePositions;
    procedure RefreshIDE;
  end;

// Include file written by StoneBirds' Compilation Date and Time Expert
{$i DateTime.inc}

const
  ProgName = 'Map Editor';
  version  = '1.10 ( Beta 3 )';

var
  Mainform : TMainform;
  firsttime : boolean;

implementation

uses UTilesForm, UNewMap, USprites, UNewSprite, UAbout,
  UViewer, UOptions, USpritePosition;

{$R *.DFM}

procedure TMainform.FormCreate( Sender : TObject );
begin
  Caption := progName + ' ' + version + ' (BetaBuild: '+ _CompileDateTime_+')';
  Application.Title := progName;

  DXDraw.width  := 640;
  DXDraw.height := 480;
  if Screen.Width = 1024 then
  begin
    DXDraw.width     := 800;
    DXDraw.height    := 600;
  end;
  if Screen.Width > 1024 then
  begin
    DXDraw.width     := 1024;
    DXDraw.height    := 780;
  end;
  DX_Draw := DXDraw;
  // Global vars to be initiali
  cam := 1;
  PosX := 1;
  PosY := 1;
  pox := 1;
  poy := 1;
  fix_tx := -1; // global pos for moving cursor
  undo_px:= -1;
  LeftMouseTile := False; // Assume we are not pressing the mouse
  // Assign the small Fonts
  ImageBackup.Canvas.Font.Name := 'Small Font';
  ImageBackup.Canvas.Font.Size := 7;
  ImageTile.Canvas.Font        := ImageBackup.Canvas.Font;
  ImageSelTile.Canvas.Font     := ImageBackup.Canvas.Font;
  // Copy glyphs
  btnNewSprite.Glyph    := btnNew.Glyph;
  // IDE
  FormResize( Sender );        // Resize all standar controls
  RefreshIDE;
  firsttime := true;
end;

procedure TMainform.FormActivate(Sender: TObject);
begin
  if firsttime then
  begin
    firsttime := False;
    LoadConfigurations;
  end;
end;

procedure TMainform.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if Application.MessageBox(
        'Do you really want to exit?',
        'Exit',  MB_OKCANCEL) = IDCancel then
  begin
    Action := caNone;
    exit;
  end;

  // Liberate Sprite memory
  if SpritesPos <> nil then
       SpritesPos.Destroy;
end;


procedure TMainform.Exit1Click( Sender : TObject );
begin
  Close;
end;

procedure TMainform.About1Click( Sender : TObject );
begin
  aboutBox.show;
end;

procedure TMainform.mnuTilesClick( Sender : TObject );
begin
  TilesForm.ShowModal;
end;

procedure TMainform.NewProject1Click( Sender : TObject );
begin
  if NewMap.ShowModal = mrOK then
  begin
    prjFileName := '';
    PosX     := Map.width div 2;
    PosY     := Map.height div 2;
    pox      := PosX;
    poy      := PosY;
    DessignScaleMap;
    SpritesPos.Free;
    SpritesPos := TSprites.Create;
    ShowTerrain;
  end;
  RefreshIDE;
end;

procedure TMainform.mnuOpenProjectClick( Sender : TObject );
begin
  with Mainform.OpenDialog do
  begin
    DefaultExt := 'map';
    Filter := 'Map files (*.map)|*.map';
    if Execute then
    begin
      Map.free;
      Map := TMap.create;
      CurrentPath := ExtractFilePath( Filename );
      prjFileName := FileName;
      Map.loadFromFile( ExtractFileName( Filename ) );
      DessignScaleMap;
    end;
  end;
  RefreshIDE;
  ShowTerrain;
end;



{   Calculates and draws the terrain
}
(*
procedure TMainform.ShowTerrainOriginal;
var
  TileW, TileH, HTileW, HTileH, StartX, StartY, kx, ky : integer;
  til, alt : byte;
  at : TTile;
  tW, tH, tOX, tOY, px, py, tx, ty : integer;
  x1, x2, y1, y2 : integer;
  ky_H, kx_W, k, pix, piy, bx, by, pcx, pcy, h, csx, csy : integer;
  sprBmp : TBitmap;
begin
  Image.canvas.Brush.Color := clWhite;
  Image.canvas.FillRect( Rect( 0, 0, Image.width, Image.height ) );
  if ( unit3.Terrain <> nil ) and ( unit3.map <> nil ) then
    with unit3.terrain do
    begin
      TileW := StndWidth;
      TileH := StndHeight;
      HTileW := TileW div 2;
      HTileH := TileH div 2;
      if PosX < pox then
      begin
        x1 := PosX;
        x2 := pox;
      end
      else
      begin
        x2 := PosX;
        x1 := pox;
      end;
      if PosY < poy then
      begin
        y1 := PosY;
        y2 := poy;
      end
      else
      begin
        y2 := PosY;
        y1 := poy;
      end;

      case Cam of
        1 :
          begin
            StartX := PosX - image.width div TileW;
            StartY := PosY;
          end;
        2 :
          begin
            StartX := PosX;
            StartY := PosY - image.width div TileW;
          end;
        3 :
          begin
            StartX := PosX + image.width div TileW;
            StartY := PosY;
          end;
      else //4:
        begin
          StartX := PosX;
          StartY := PosY + image.width div TileW;
        end;
      end; //case

      ky_H := ( image.height div TileH ); // Improves speed
      kx_W := ( image.width div TileW );
      ky   := 0;
      while ky < ky_H do
      begin
        kx   := 0;
        while kx < kx_W do //righe pari1
        begin
          case Cam of
            1 :
              begin
                px := kx + StartX + ky;
                py := StartY - kx + ky;
              end;
            2 :
              begin
                px := + kx + StartX + ky;
                py := StartY + kx - ky;
              end;
            3 :
              begin
                px := -kx + StartX - ky;
                py := StartY + kx - ky;
              end;
            else // 4:
              begin
                px := -kx + StartX - ky;
                py := StartY - kx + ky;
              end;
          end; //case
          til := Map.GetTile( px, py );
          alt := Map.GetAltitude( px, py );
          at  := tiles.Items[ til ];
          tW  := at.width;
          tH  := at.height;
          tOX := at.OriginX;
          tOY := at.OriginY;
          tx  := kx * TileW;
          ty  := ky * TileH - alt * LevelShift + at.ShiftY;
          BitBlt( image.canvas.handle, tx, ty, tW, tH, Terrain.bmp.canvas.handle, tOX, tOY, SRCAND );
          //if ( ( px >= x1 ) and ( px <= x2 ) ) and ( ( py >= y1 ) and ( py <= y2 ) ) then
          if cbDebugTiles.checked then
          begin
            Image.canvas.Brush.style := bsClear;
            Image.canvas.pen.color   := clBlack;
            image.canvas.Rectangle( tx, ty, tx + tw, ty + th );
            image.canvas.TextOut( tx+1, ty+1, inttostr( px )+ ','+inttostr( py ));
          end;
          inc( kx );
        end; // while kx <


        Image.canvas.Brush.style := bsClear;
        Image.canvas.pen.color   := clBlack;
        kx   := 0;
        while kx < ( 1 + kx_W) do //righe pari1
//        for kx := 0 to 1 + kx_W do //righe dispari
        begin
          case Cam of
            1 :
              begin
                px := kx + StartX + ky;
                py := StartY - kx + ky + 1;
              end;
            2 :
              begin
                px := kx + StartX + ky;
                py := StartY + kx - ky - 1;
              end;
            3 :
              begin
                px := -kx + StartX - ky;
                py := StartY + kx - ky - 1;
              end;
          else //4:
            begin
              px := -kx + StartX - ky;
              py := StartY - kx + ky + 1;
            end;
          end; //case
          til := Map.GetTile( px, py );
          alt := Map.GetAltitude( px, py );
          at := Tiles.Items[ til ];
          tW := at.width;
          tH := at.height;
          tOX := at.OriginX;
          tOY := at.OriginY;
          tx := kx * TileW - HTileW;
          ty := ky * TileH + HTileH - alt * LevelShift + at.ShiftY;
          BitBlt( image.canvas.handle, tx, ty, tW, tH, Terrain.bmp.canvas.handle, tOX, tOY, SRCAND );
          //if ( ( px >= x1 ) and ( px <= x2 ) ) and ( ( py >= y1 ) and ( py <= y2 ) ) then
          //  image.canvas.Rectangle( tx, ty, tx + tw, ty + th );
          inc( kx );
        end;
        inc( ky );
      end;
 // disegno sprite
      if cbShowSprites.checked then
      begin
        pix := image.Width div 2 + HTileW;
        piy := pix div 2 - HTileH;

        with SpriteMovingForm.SpriteGrid do
        begin
          k := fixedRows;
          while cells[ 0, k ] <> '' do
          begin
            pcx := strtoint( cells[ 3, k ] );
            pcy := strtoint( cells[ 4, k ] );
            bx := strtoint( cells[ 5, k ] );
            by := strtoint( cells[ 6, k ] );
            h := Map.GetAltitude( pcx div 100, pcy div 100 );
            pcx := pcx - ( 100 * PosX ); // trasforma in coord relative al punto inserimento attuale
            pcy := pcy - ( 100 * PosY );
            csx := pix + round( ( ( pcx - pcy ) / 100 ) * HTileW ); // coord schermo := punto inserimento + px + py
            csy := piy + round( ( ( pcx + pcy ) / 100 ) * HTileH );
            csx := csx - bx; //toglie base sprite
            csy := csy - by - h * LevelShift; // aggiunge altezza tile
            if ( csx >= 0 ) and ( csx <= Image.width ) and ( csy >= 0 ) and ( csy <= image.height ) then
            begin // disegna sprite !!
              sprBmp := TBitmap( SpriteMovingForm.ImageList[ k - 1 ] );
              Image.canvas.BrushCopy( Rect( csx, csy, csx + sprBmp.width, csy + sprBmp.height ), sprBmp, Rect( 0, 0, sprBmp.width, sprBmp.height ), clWhite );
              if cbDebugTiles.checked then
              begin
                Image.canvas.Brush.style := bsClear;
                Image.canvas.pen.color   := clWhite;
                image.canvas.Rectangle( csx, csy, csx + sprBmp.Width, csy + sprBmp.Height );
                image.canvas.TextOut( tx+1, ty+1, 'ID : '+inttostr( k ));
              end;
            end;
            inc( k );
          end;
        end;
      end;
      image.repaint;
      fix_tx := -1; // To restore var
      MoveScaleMap;
    end
  else
    ShowMessage( 'You need a Map and a Tile before showing it on the screen!' );
end;
*)

{   Calculates and draws the terrain
    original, splified
}
(*
procedure TMainform.ShowTerrain;
var
  TileW, TileH, HTileW, HTileH, StartX, StartY, kx, ky : integer;
  til, alt : byte;
  at : TTile;
  tW, tH, tOX, tOY, px, py, tx, ty : integer;
  x1, x2, y1, y2 : integer;
  ky_H, kx_W, k, pix, piy, bx, by, pcx, pcy, h, csx, csy : integer;
  sprBmp : TBitmap;
begin
  Image.canvas.Brush.Color := clWhite;
  Image.canvas.FillRect( Rect( 0, 0, Image.width, Image.height ) );
  if ( unit3.Terrain <> nil ) and ( unit3.map <> nil ) then
    with unit3.terrain do
    begin
      TileW := StndWidth;
      TileH := StndHeight;
      HTileW := TileW div 2;
      HTileH := TileH div 2;

{      x2 := PosX;
      x1 := pox;

      y2 := PosY;
      y1 := poy;}

      StartX := PosX - image.width div TileW;
      StartY := PosY;

      ky_H := ( image.height div TileH ); // Improves speed
      kx_W := ( image.width div TileW );
      ky   := 0;
      while ky < ky_H do
      begin
        kx   := 0;
        while kx < kx_W do //righe pari1
        begin
          px := kx + StartX + ky;
          py := StartY - kx + ky;

          til := Map.GetTile( px, py );
          alt := Map.GetAltitude( px, py );
          at  := tiles.Items[ til ];
          tW  := at.width;
          tH  := at.height;
          tOX := at.OriginX;
          tOY := at.OriginY;
          tx  := kx * TileW;
          ty  := ky * TileH - alt * LevelShift + at.ShiftY;
          BitBlt( image.canvas.handle, tx, ty, tW, tH, Terrain.bmp.canvas.handle, tOX, tOY, SRCAND );
          if cbDebugTiles.checked then
          begin
            Image.canvas.Brush.style := bsClear;
            Image.canvas.pen.color   := clBlack;
            image.canvas.Rectangle( tx, ty, tx + tw, ty + th );
            image.canvas.TextOut( tx+1, ty+1, inttostr( px )+ ','+inttostr( py ));
          end;
          inc( kx );
        end; // while kx <


        Image.canvas.Brush.style := bsClear;
        Image.canvas.pen.color   := clBlack;
        kx   := 0;
        while kx < ( 1 + kx_W) do //righe pari1
        begin
          px := kx + StartX + ky;
          py := StartY - kx + ky + 1;

          til := Map.GetTile( px, py );
          alt := Map.GetAltitude( px, py );
          at := Tiles.Items[ til ];
          tW := at.width;
          tH := at.height;
          tOX := at.OriginX;
          tOY := at.OriginY;
          tx := kx * TileW - HTileW;
          ty := ky * TileH + HTileH - alt * LevelShift + at.ShiftY;
          BitBlt( image.canvas.handle, tx, ty, tW, tH, Terrain.bmp.canvas.handle, tOX, tOY, SRCAND );
          inc( kx );
        end;
        inc( ky );
      end;


 // disegno sprite
      if cbShowSprites.checked then
      begin
        pix := image.Width div 2 + HTileW;
        piy := pix div 2 - HTileH;

        with SpriteMovingForm.SpriteGrid do
        begin
          k := fixedRows;
          while cells[ 0, k ] <> '' do
          begin
            pcx := strtoint( cells[ 3, k ] );
            pcy := strtoint( cells[ 4, k ] );
            bx := strtoint( cells[ 5, k ] );
            by := strtoint( cells[ 6, k ] );
            h := Map.GetAltitude( pcx div 100, pcy div 100 );
            pcx := pcx - ( 100 * PosX ); // trasforma in coord relative al punto inserimento attuale
            pcy := pcy - ( 100 * PosY );
            csx := pix + round( ( ( pcx - pcy ) / 100 ) * HTileW ); // coord schermo := punto inserimento + px + py
            csy := piy + round( ( ( pcx + pcy ) / 100 ) * HTileH );
            csx := csx - bx; //toglie base sprite
            csy := csy - by - h * LevelShift; // aggiunge altezza tile
            if ( csx >= 0 ) and ( csx <= Image.width ) and ( csy >= 0 ) and ( csy <= image.height ) then
            begin // disegna sprite !!
              sprBmp := TBitmap( SpriteMovingForm.ImageList[ k - 1 ] );
              Image.canvas.BrushCopy( Rect( csx, csy, csx + sprBmp.width, csy + sprBmp.height ), sprBmp, Rect( 0, 0, sprBmp.width, sprBmp.height ), clWhite );
              if cbDebugTiles.checked then
              begin
                Image.canvas.Brush.style := bsClear;
                Image.canvas.pen.color   := clWhite;
                image.canvas.Rectangle( csx, csy, csx + sprBmp.Width, csy + sprBmp.Height );
                image.canvas.TextOut( tx+1, ty+1, 'ID : '+inttostr( k ));
              end;
            end;
            inc( k );
          end;
        end;
      end;
      image.repaint;
      fix_tx := -1; // To restore var
      MoveScaleMap;
    end
  else
    ShowMessage( 'You need a Map and a Tile before showing it on the screen!' );
end;
*)

{   Calculates and draws the terrain

    This function uses less power because it doesn't use the altitude
}

procedure TMainform.ShowTerrain;
var
  TileW, TileH, HTileW, HTileH, StartX, StartY, kx, ky : integer;
  til, alt : byte;
  at : TTile;
  tW, tH, tOX, tOY, px, py, tx, ty : integer;
  x1, x2, y1, y2 : integer;
  ky_H, kx_W, k, pix, piy, bx, by, pcx, pcy, h, csx, csy, spr_width, spr_Height : integer;
  sprBmp : TBitmap;
begin
  //Image.canvas.Brush.Color := clWhite;
  //Image.canvas.FillRect( Rect( 0, 0, Image.width, Image.height ) );

  if ( unit3.Terrain <> nil ) and ( unit3.map <> nil ) then
    with unit3.terrain do
    begin

      StatusBar1.Panels[9].Text  := inttostr( Posx ); // PosX
      StatusBar1.Panels[11].Text := inttostr( Posy); // PosY


      TileW := StndWidth;
      TileH := StndHeight;

      HTileW := TileW div 2;
      HTileH := TileH div 2;

      StartX := PosX - DXDraw.width div TileW;
      StartY := PosY;

      ky_H := ( DXDraw.height div TileH ); // Improves speed
      kx_W := ( DXDraw.width div TileW );

      ky   := -1;
      while ky < (ky_H+1) do
      begin
        kx := 0;
        while kx < (kx_W + 1 ) do //righe pari1
        begin
          px := kx + StartX + ky;
          py := StartY - kx + ky;

          til := Map.GetTile( px, py );
          alt := Map.GetAltitude( px, py );
          at  := tiles.Items[ til ];
          tW  := at.width;
          tH  := at.height;
          tOX := at.OriginX;
          tOY := at.OriginY;
          tx  := kx * TileW;
          ty  := ky * TileH - alt * LevelShift + at.ShiftY;

          TileSurface.Draw(tx, ty, Rect(tOX,tOY,tOX+tW,toy+th), Terrain.Surface, True);
          //TileSurface.DrawAlpha(Rect(tx, ty, tx+tw,ty+th), Rect(tOx,tOy,tox+tW,toy+th), Terrain.Surface, True, 150);

          //BitBlt( image.canvas.handle, tx, ty, tw, th, Terrain.bmp.canvas.handle, tOX, tOY, SRCAND );
          {if cbDebugTiles.checked then
          begin
            Image.canvas.Brush.style := bsClear;
            Image.canvas.pen.color   := frmOptions.clDebugTile.Color;
            image.canvas.Rectangle( tx, ty, tx + tw, ty + th );
            Image.canvas.pen.color   := frmOptions.clDebugTile.Color;
            image.canvas.TextOut( tx+1, ty+1, inttostr( px )+ ','+inttostr( py ));
          end;}
          inc( kx );
        end; // while kx <


        {Image.canvas.Brush.style := bsClear;
        Image.canvas.pen.color   := clBlack;}
        kx := 0;
        while kx < ( kx_W + 2 ) do //righe pari1
        begin
          px := kx + StartX + ky;
          py := StartY - kx + ky + 1;

          til := Map.GetTile( px, py );
          alt := Map.GetAltitude( px, py );
          at  := Tiles.Items[ til ];
          tW  := at.width;
          tH  := at.height;
          tOX := at.OriginX;
          tOY := at.OriginY;
          tx  := kx * TileW - HTileW;
          ty  := ky * TileH + HTileH - alt * LevelShift + at.ShiftY;


          TileSurface.Draw(tx, ty, Rect(tOx,tOy,tox+tW,toy+th), Terrain.Surface, True);
          //TileSurface.DrawAlpha(Rect(tx, ty, tx+tw,ty+th), Rect(tOx,tOy,tox+tW,toy+th), Terrain.Surface, True, 150);

          //BitBlt( image.canvas.handle, tx, ty, tw, th, Terrain.bmp.canvas.handle, tOX, tOY, SRCAND );

          {if cbDebugTiles.checked then
          begin
            Image.canvas.Brush.style := bsClear;
            Image.canvas.pen.color   := frmOptions.clDebugTile.Color;
            image.canvas.Rectangle( tx, ty, tx + tw, ty + th );
            Image.canvas.pen.color   := frmOptions.clDebugTile.Color;
            image.canvas.TextOut( tx+1, ty+1, inttostr( px )+ ','+inttostr( py ));
          end;}
          inc( kx );
        end;
        inc( ky );
      end;

 // disegno sprite
      if (cbShowSprites.checked) and (SpritesPos <> nil) then
      begin
        pix := DXDraw.Width div 2 + HTileW;
        piy := pix div 2 - HTileH;


        for k := 0 to SpritesPos.FSpriteList.Count - 1 do
        begin
          with TSprite(SpritesPos.FSpriteList[k]) do
          begin
            pcx := X;
            pcy := Y;
            bx := BaseX;
            by := BaseY;
            h := Map.GetAltitude( pcx div 100, pcy div 100 );
            pcx := pcx - ( 100 * PosX ); // trasforma in coord relative al punto inserimento attuale

            pcy := pcy - ( 100 * PosY );
            csx := round( ( ( pcx - pcy ) / 100 ) * HTileW ); // coord schermo := punto inserimento + px + py
            csx := csx + pix; // coord schermo := punto inserimento + px + py

            csy := piy + round( ( ( pcx + pcy ) / 100 ) * HTileH );
            csx := csx - bx; //toglie base sprite
            csy := csy - by - h * LevelShift; // aggiunge altezza tile
            if ( csx >= 0 ) and ( csx <= DXDraw.width ) and ( csy >= 0 ) and ( csy <= DXDraw.height ) then
            begin // disegna sprite !!
              //sprBmp := TBitmap( SpriteMovingForm.ImageList[ k - 1 ] );
              with TFrame(TSprite(SpritesPos.FSpriteList[k]).FSpriteData.FFrames[0]) do
              begin
                spr_width  := FRect.Right - FRect.Left;
                spr_Height := FRect.Bottom - FRect.Top;

                TileSurface.Draw(csx, csy, FRect, Surface, True);
                //TileSurface.DrawAlpha(Rect(csx, csy, csx+spr_width, csy+spr_height), FRect, Surface, False, 50);
              end;
              if cbDebugSprites.checked then
              begin
                with TileSurface.Canvas do
                begin
                  Font.Name   := 'Small Font';
                  Font.Size   := 7;
                  Brush.style := bsClear;
                  pen.color   := frmOptions.clDebugSprite.Color;
                  Rectangle( csx, csy, csx + spr_Width, csy + spr_Height );
                  font.color  := frmOptions.clDebugSprite.Color;
                  TextOut( csx+1, csy+1, 'ID : '+inttostr( k ));
                  TextOut( csx+1, csy+10, 'X : '+inttostr( csx ) + ' Y : '+inttostr( csy ));
                  TextOut( csx+1, csy+20, 'PX : '+inttostr(X)  + ' PY : '+inttostr(Y) );
                  // Put the base point on the screen
                  pen.color   := clBlack;
                  Rectangle(csx+bx-2,csy+by-2,csx+bx+4,csy+by+4);
                  pen.color   := clRed;
                  Rectangle(csx+bx,csy+by,csx+bx+2,csy+by+2);
                  Release;
                end;
              end; // if cbDebug
            end; // if Coord
          end; // with
        end; // for

      end;
      fix_tx := -1; // To restore var
      MoveScaleMap;
    end;
end;

{
}

procedure TMainform.Up1Click( Sender : TObject );
begin
  PosX := PosX - 1;
  PosY := PosY - 1;
  if not ( ssShift in shfstate ) then
  begin
    poX := PosX;
    poY := PosY;
  end;
  ShowTerrain;
end;

procedure TMainform.Down1Click( Sender : TObject );
begin
  PosX := PosX + 1;
  PosY := PosY + 1;
  if not ( ssShift in shfstate ) then
  begin
    poX := PosX;
    poY := PosY;
  end;
  ShowTerrain;
end;

procedure TMainform.Left1Click( Sender : TObject );
begin
  PosX := PosX - 1;
  PosY := PosY + 1;
  if not ( ssShift in shfstate ) then
  begin
    poX := PosX;
    poY := PosY;
  end;
  ShowTerrain;

end;

procedure TMainform.Right1Click( Sender : TObject );
begin
  PosX := PosX + 1;
  PosY := PosY - 1;
  if not ( ssShift in shfstate ) then
  begin
    poX := PosX;
    poY := PosY;
  end;
  ShowTerrain;
end;


{
}
procedure TMainform.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
  if Button = btNext then right1Click(Sender) else Left1Click(Sender);
end;

procedure TMainform.UpDown2Click(Sender: TObject; Button: TUDBtnType);
begin
  if Button = btNext then Up1Click(Sender) else Down1Click(Sender);
end;



procedure TMainform.OpenTileFile1Click( Sender : TObject );
begin
  with Mainform.OpenDialog do
  begin
    DefaultExt := 'tls';
    Filter := 'Tile List files (*.tls)|*.tls';
    if Execute then
    begin
      Terrain.free;
      Terrain := TTerrain.create;
      CurrentPath := ExtractFilePath( Filename );
      Terrain.loadFromFile( ExtractFileName( Filename ) );
      ImageTiled.Picture.Bitmap := Terrain.Bmp;
      DessignScaleMap;
    end;
  end;
  RefreshIDE;
  if map <> nil then ShowTerrain;
end;

procedure TMainform.Raise1Click( Sender : TObject );
var
  alt : integer;
begin
  alt := map.getaltitude( PosX, PosY );
  if alt < maxalt then
  begin
    alt := alt + 1;
    map.setaltitude( PosX, PosY, alt );
    ShowTerrain;
  end;
end;

procedure TMainform.Lower1Click( Sender : TObject );
var
  alt : integer;
begin
  alt := map.getaltitude( PosX, PosY );
  if alt > 0 then
  begin
    alt := alt - 1;
    map.setaltitude( PosX, PosY, alt );
    ShowTerrain;
  end;
end;

procedure TMainform.UP2Click( Sender : TObject );
begin
  PosX := PosX - 1;
  if not ( ssShift in shfstate ) then
  begin
    poX := PosX;
    poY := PosY;
  end;
  ShowTerrain;

end;

procedure TMainform.UpRight1Click( Sender : TObject );
begin
  PosY := PosY - 1;
  if not ( ssShift in shfstate ) then
  begin
    poX := PosX;
    poY := PosY;
  end;
  ShowTerrain;

end;

procedure TMainform.DownLeft1Click( Sender : TObject );
begin
  PosY := PosY + 1;
  if not ( ssShift in shfstate ) then
  begin
    poX := PosX;
    poY := PosY;
  end;
  ShowTerrain;

end;

procedure TMainform.DownRight1Click( Sender : TObject );
begin
  PosX := PosX + 1;
  if not ( ssShift in shfstate ) then
  begin
    poX := PosX;
    poY := PosY;
  end;
  ShowTerrain;

end;

procedure TMainform.FormKeyDown( Sender : TObject; var Key : Word;
  Shift : TShiftState );
var
  InputString: string;
begin
  LastKey := key;
  case Key of
    VK_SHIFT :
      begin
        if ssShift in shfState then
          shfstate := shfstate - [ ssShift ]
        else
          shfstate := shfstate + [ ssShift ];
      end;
    VK_UP, VK_NUMPAD8    : Up1Click( self );
    VK_DOWN, VK_NUMPAD2  : Down1Click( self );
    VK_LEFT, VK_NUMPAD4  : Left1Click( self );
    VK_RIGHT, VK_NUMPAD6 : Right1Click( self );
    VK_HOME, VK_NUMPAD7  : Up2Click( self );
    VK_PRIOR, VK_NUMPAD9 : UpRight1Click( self );
    VK_NEXT, VK_NUMPAD3  : DownRight1Click( self );
    VK_END, VK_NUMPAD1   : DownLeft1Click( self );
    { Imput tile number }
    84: begin // T
         InputString:= InputBox('Input Box', 'Tile Number?', '0');
         SelectNrTile( strtoint( InputString ) );
        end;
    else begin
          //ShowMessage(inttostr(key));
          LastKey := 0;
         end;
  end; //case

  StatusBar1.update;
end;

procedure TMainform.N3Click( Sender : TObject );
var
  til : integer;
begin
  til := map.gettile( PosX, PosY );
  til := strtoint( inputbox( 'Change Tile', 'Insert Tile ID', inttostr( til ) ) );
  if ( til >= 0 ) and ( til < terrain.number ) then
  begin
    map.settile( PosX, PosY, til );
    ShowTerrain;
  end;
end;

procedure TMainform.mnuSpritesClick( Sender : TObject );
begin
  SpriteForm.ShowModal;
end;

procedure TMainform.N1stview1Click( Sender : TObject );
begin
  N1stview1.checked := true;
  Cam := 1;
  ShowTerrain;
end;

procedure TMainform.N2ndView1Click( Sender : TObject );
begin
  N2ndview1.checked := true;
  Cam := 2;
  ShowTerrain;
end;

procedure TMainform.N3rdView1Click( Sender : TObject );
begin
  N3rdview1.checked := true;
  Cam := 3;
  ShowTerrain;
end;

procedure TMainform.N4thView1Click( Sender : TObject );
begin
  N4thview1.checked := true;
  Cam := 4;
  ShowTerrain;

end;

procedure TMainform.Op1Click( Sender : TObject );
var
  s : string;
begin
  with Mainform.OpenDialog do
  begin
    Filter := 'Level files (*.pos,*.tls,*.map)|*.pos;*.tls;*.map';
    if Execute then
    begin
      Screen.Cursor := crHourGlass;
      selected_SpriteData := nil;
      prjFileName   := OpenDialog.FileName;
      CurrentPath   := ExtractFilePath( prjFileName );
      s := ExtractFileName( Filename );
      if pos( '.', s ) > 0 then //toglie estensione
        s := copy( s, 1, pos( '.', s ) - 1 );
      if not FileExists( s + '.tls' ) then
      begin
        ShowMessage( s + '.tls doesn''t exist !' );
        exit;
      end;
      if not FileExists( s + '.map' ) then
      begin
        ShowMessage( s + '.map doesn''t exist !' );
        exit;
      end;
      Terrain.free;
      Terrain := TTerrain.create;
      Terrain.loadFromFile( s + '.tls' );
      Screen.Cursor := crHourGlass;
      ImageTiled.picture.Bitmap := Terrain.Bmp;
      Map.free;
      Map := TMap.create;
      Map.loadFromFile( s + '.map' );

      // Open NEW Sprite positios
      Screen.Cursor := crHourGlass;
      SpritesPos.Free;
      SpritesPos := TSprites.Create;
      if FileExists( s + '.pos' ) then
      begin
         SpritesPos.LoadFromFile( s + '.pos' );
         ShowSpritesinWindow;
      end;

      Screen.Cursor := crHourGlass;
      DessignScaleMap;
      Screen.Cursor := crHourGlass;
      ShowTerrain;
      Screen.Cursor := crDefault;
    end;
  end;
  RefreshIDE;
end;

{   Save AS Dialog
}
procedure TMainform.mnuSaveAsProjectClick( Sender : TObject );
begin
  SaveDialog1.DefaultExt := 'map';
  SaveDialog1.Filter := 'Map files (*.map)|*.map';

  if SaveDialog1.Execute then
      SaveToFile( SaveDialog1.FileName );
end;

{   Save the file directly
}
procedure TMainform.mnuSaveMapClick(Sender: TObject);
begin
   if prjFileName = '' then
       mnuSaveAsProjectClick( Sender ) else SaveToFile( prjFileName );
end;

{   This procedure does all the stuff to saving to the disk
}
procedure TMainForm.SaveToFile( name : string);
var
  FileN : string;
begin
  FileN := Name ;
  if pos( '.', FileN ) > 0 then //toglie estensione
      FileN := copy( FileN, 1, pos( '.', FileN ) - 1 );
  unit3.Map.SaveToFile( FileN + '.map' );
  SpritesPos.SaveToFile( FileN + '.pos' );
end;


procedure TMainform.mnuCreateGlobalMapClick( Sender : TObject );
var
  GMapBmp : TBitmap;
  s : string;
//	color:TColor;
  idTile : byte;
  CurrTile : TTile;
  ox, oy, tx, ty : integer;
begin
  if ( unit3.Terrain <> nil ) and ( unit3.map <> nil ) then
  begin
    with unit3.Map, unit3.Terrain do
    begin
      GMapBmp := TBitmap.create;
      screen.Cursor := crHourGlass;
      try
        GMapBmp.LoadFromFile( NameImage );
        GMapBmp.width := Map.Width * 2;
        GMapBmp.Height := Map.Height * 2;
        for tx := 0 to Map.width - 1 do
          for ty := 0 to Map.height - 1 do
          begin
            idTile := GetTile( tx, ty );
            CurrTile := Tiles[ idTile ];
     //color:=Bmp.Canvas.Pixels[CurrTile.OriginX+ox,CurrTile.OriginY+oy];
     //GMapBmp.Canvas.Pixels[tx,ty]:=color;
            ox := CurrTile.OriginX + CurrTile.Width div 2 - 1; //offsetX;
            oy := CurrTile.OriginY + CurrTile.Height div 2 - 1; //offsetY;
            GMapBmp.Canvas.CopyRect( Rect( tx * 2, ty * 2, tx * 2 + 2, ty * 2 + 2 ), Bmp.Canvas, Rect( ox, oy, ox + 2, oy + 2 ) );
          end;
        s := Map.MapName;
        if (pos( '.', s ) > 0) or (s = 'NewMap') then //toglie estensione
          s := copy( s, 1, pos( '.', s ) - 1 ) + '.bmp';
        if FileExists( s ) and ( MessageDlg( 'Do you want to overwrite ' + s + ' ?', mtConfirmation, [ mbYes, mbNo ], 0 ) = mrNo ) then
          showMessage( 'GlobalMap not saved !' )
        else
        begin
          GMapBmp.SaveToFile( s );
          showMessage( 'GlobalMap saved as ' + s );
          FrmViewer.Image1.Picture.LoadFromFile( s );
          FrmViewer.ShowModal;
        end;
      finally
        GMapBmp.free;
        Screen.Cursor := crDefault;
      end;
    end; //with
  end
  else
    ShowMessage( 'You need a Map and a Tile before !' );
end;

//

procedure TMainform.DessignScaleMap;
begin
  if ( unit3.Terrain <> nil ) and ( unit3.map <> nil ) then
  begin
   Shape2.Width   := (((DXDraw.Width div Terrain.StndWidth) * ShapeMap.Width) div Map.Width);
   Shape2.Height  := (((DXDraw.Height div Terrain.StndHeight) * ShapeMap.Height) div Map.Height);
   {ScrollBarH.Max := ShapeMap.Height;
   ScrollBarV.Max := ShapeMap.Width;
   ScrollBarH.Position := PosX;
   ScrollBarV.Position := PosY;}
  end;
end;

procedure TMainform.MoveScaleMap;
begin
//   Shape2.Height := ((Map.Height * 100) div 10000);
  if ( unit3.Terrain <> nil ) and ( unit3.map <> nil ) then
  begin
   Shape2.Left := (PosX * ShapeMap.Width)  div Map.Width;
   Shape2.Top  := (PosY * ShapeMap.Height) div Map.Height;
   {ScrollBarH.Position := PosX;
   ScrollBarV.Position := PosY; }
  end;
end;



//*************************************************************************
// Tiled on the screen
// by John Lohmeyer - 2000

procedure TMainform.ImageTiledMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
  x1, x2, y1, y2, til, k : integer;
  at : TTile;
begin
  if terrain = nil then exit;      // Umm not tiled loaded
  with unit3.terrain do
  begin
    til := -1;
    for k := 0 to number - 1 do
    begin
      at := tiles[ k ];
      X1 := at.OriginX;
      Y1 := at.OriginY;
      X2 := at.OriginX + at.width;
      Y2 := at.OriginY + at.height;
      if ( X >= X1 ) and ( X <= X2 ) and ( Y >= Y1 ) and ( Y <= Y2 ) then til := k;
    end;
    if til > -1 then
    begin
      at := terrain.tiles[ til ];
      //      StatusBar.panels[ 3 ].text := at.name;
      StatusBar1.panels[ 0 ].text := 'ID:'+inttostr( at.id )+', '+at.name;
    end;
  end; //with
end;

procedure TMainform.ImageTiledMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  k, x1, x2, y1, y2,  til : integer;
  at : TTile;
begin
  if unit3.terrain = nil then exit;
  til := -1;
  with unit3.terrain do
  begin
    for k := 0 to number - 1 do
    begin
      at := tiles[ k ];
      X1 := at.OriginX;
      Y1 := at.OriginY;
      X2 := at.OriginX + at.width;
      Y2 := at.OriginY + at.height;
      if ( X >= X1 ) and ( X <= X2 ) and ( Y >= Y1 ) and ( Y <= Y2 ) then
        til := k;
    end;
    SelectNrTile( til );
  end; //with
end;

{   Select the tile by number...
}
procedure TMainform.SelectNrTile( tile : integer );
var
  at : TTile;
begin
  with unit3.terrain do
  begin
    if ( tile >= 0 ) and ( tile < number ) then
    begin
      at := tiles[ tile ];
      ImageSelTile.canvas.Brush.Color := clWhite;
      ImageSelTile.canvas.FillRect( Rect( 0, 0, ImageSelTile.width, ImageSelTile.height ) );
      BitBlt( ImageSelTile.canvas.handle, 0, 0, at.Width, at.Height, Terrain.bmp.canvas.handle, at.OriginX, at.OriginY, SRCCopy );
      ImageSelTile.Canvas.TextOut( 2, 35, 'ID: ' + inttostr( tile ));
      ImageSelTile.Refresh;
      selectedTile := tile;
    end;
  end;
end;

{   Increase the selected the tile
}
procedure TMainform.btnTileUpClick(Sender: TObject);
begin
   SelectNrTile( selectedTile + 1 );
end;

{   Decrease the selected the tile
}
procedure TMainform.btnTileDownClick(Sender: TObject);
begin
   SelectNrTile( selectedTile - 1 );
end;
{   Just fill it on the map
}
procedure TMainform.btnTileFillClick(Sender: TObject);
begin
    ShowTerrain;
end;

procedure TMainform.ImageMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if ( unit3.Terrain = nil ) or ( unit3.map = nil ) then exit;
  if (LastX <> X) or (LastY <> Y) then
  begin
    LastX := X;
    LastY := Y;
    moved := True;
  end;
end;


{   Dessign tiles when selected
}
procedure TMainform.TileMouseMove( X, Y : integer);
var
  TileW, TileH, HTileW, HTileH, StartX, StartY, kx, ky, csx, csy : integer;
  til, alt : byte;
  at : TTile;
  tW, tH, px, py, tx, ty, np : integer;
begin
//  StatusBar1.SimpleText:= 'X:'+inttostr(X) + ', Y:' +inttostr(Y);
  if ( unit3.Terrain <> nil ) and ( unit3.map <> nil ) then
    with unit3.terrain do
    begin
      DXDraw.cursor := crNone; // NO cursors
      TileW        := StndWidth;
      TileH        := StndHeight;
      HTileW       := TileW div 2;
      HTileH       := TileH div 2;

      if not moved then
      begin
         with DXDraw.Surface.Canvas do
         begin
            Brush.Style := bsClear;
            pen.color := clWhite;
            Rectangle( LastTX, LastTY, LastTX + LastTW, LastTY + LastTH );
            pen.color := clBlack;
            Rectangle( LastTX+1, LastTY+1, LastTX + LastTW-1, LastTY + LastTH-1 );

            font.color := clBlack;
            textout(LastTx + 3, LastTY + 3, 'ID:'+ inttostr(fix_tile) );
            tw := textWidth(inttostr(fix_px) + ',' + inttostr(fix_py));
            np := ((LastTW - tw) div 2) + LastTX;
            textout(np + 1, LastTY + 21, inttostr(fix_px) + ',' + inttostr(fix_py) );

            font.color := clWhite;
            textout(LastTx + 2, LastTY + 2, 'ID:'+ inttostr(fix_tile) );
            textout(np, LastTY + 20, inttostr(fix_px) + ',' + inttostr(fix_py) );

            Release;
            if (selected_SpriteData <> nil) and (btnEditSprite.Down) then
                with selected_SpriteData do
                begin
                  csx := LastTX - FFrames[0].BaseOffset.X + HTileW;
                  csy := LastTY - FFrames[0].BaseOffset.Y + HTileH;
                  //csy := csy - by - h * LevelShift; // aggiunge altezza tile
                  DXDraw.Surface.Draw(csx , csy , FFrames[0].FRect, FFrames[0].Surface, True);
                end;
         end;
         exit
      end;
      moved := False;

      StartX := PosX - DXDraw.width div TileW;
      StartY := PosY;

      ky := 0;
      while ky < ( DXDraw.height div TileH ) do
      begin
        kx := 0;
        while kx < ( DXDraw.width div TileW ) do //righe pari1
        begin
          px := kx + StartX + ky;
          py := StartY - kx + ky;
//          for np := 1 downto 0 do // Get the two levels on the map
          np := 1;
          while np >= 0 do
          begin
            til := Map.GetTile( px, py + np);
            alt := Map.GetAltitude( px, py + np);
            at  := tiles.Items[ til ];
            tW  := at.width;
            tH  := at.height;
            if np = 0 then
            begin
              tx  := kx * TileW;
              ty  := ky * TileH - alt * LevelShift + at.ShiftY;
            end
            else
            begin
              tx := kx * TileW - HTileW;
              ty := ky * TileH + HTileH - alt * LevelShift + at.ShiftY;
            end;

            if ( ( x >= tx ) and ( y >= ty ) ) and ( ( x <= (tx + tw)) and ( y <= (ty + th)) ) then
            begin
             // Show wich tile we are on
               ImageTile.canvas.Brush.Color := clWhite;
               ImageTile.canvas.FillRect( Rect( 0, 0, ImageTile.width, ImageTile.height ) );
               BitBlt( imageTile.canvas.handle, 0, 0, tW, tH, Terrain.bmp.canvas.handle, at.OriginX, at.OriginY, SRCCopy );
               ImageTile.Canvas.TextOut( 2, 35, 'ID: ' + inttostr( til ));
               with DXDraw.Surface.Canvas do
               begin
                  Brush.Style := bsClear;
                  pen.color := clWhite;
                  Rectangle( tx, ty, tx + tw, ty + th );
                  pen.color := clBlack;
                  Rectangle( tx+1, ty+1, tx + tw-1, ty + th-1 );
                  LastTX := tx; LastTY := ty; LastTW := tw; LastTH := th;
                  Release;
               end;

               {if cbDebugTiles.checked then
               begin
                  Image.canvas.pen.color   := clWhite;
                  Image.canvas.Rectangle( tx, ty, tx + tw, ty + th );
                  Image.canvas.TextOut( tx+1, ty+1, inttostr( px )+ ','+inttostr( py ));
               end;}
               // Status bar
               StatusBar1.Panels[7].Text := inttostr( alt ); // Level
               //    pcy := pcy + ( 100 div PosY );
               if btnEditSprite.Down then
               begin
                  csx := Px * 100 + 50 ;
                  csy := (Py + np) * 100 + 50 ;
                  StatusBar1.Panels[3].Text := inttostr( csx ); // X
                  StatusBar1.Panels[5].Text := inttostr( csy ); // Y
               end
               else
               begin
                  StatusBar1.Panels[3].Text := inttostr( px ); // X
                  StatusBar1.Panels[5].Text := inttostr( py + np); // Y
               end;

               // Some global var to known where we are
               fix_px := px;
               fix_py := py + np;
               fix_tx := tx;
               fix_ty := ty;
               fix_tw := tw;
               fix_th := th;
               fix_tile := til;
               // Some status info
               lblType.Caption  := 'Type:  ' + inttostr( fix_tile );
               lblPlane.Caption := 'Plane: ' + inttostr( at.IDPlane );

               ImageTile.Refresh;
               exit;
            end; // If coordinates mouse
            dec(np);
         end; // while np
         inc(kx);
        end; // while kx
        inc(ky);
      end; // while ky
    end;
end;

{   Draw the tile on the map with the selected Tile
}
procedure TMainform.ImageMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if ( Terrain = nil ) or ( Map = nil ) then exit;
  if Button = mbLeft then
  begin
     if btnEditSprite.Down then
     begin
       DrawSprite;
     end
     else
     begin
       if LastKey = 80 then
            SelectNrTile( fix_tile )    // Grab the tile with the Ctrl key and mouse down
           else
            DrawTile;
       LastKey := 0;      // delete last key
     end;
  end;
end;

// Release the mouse button
procedure TMainform.ImageMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  LeftMouseTile := False;   // We are NOT presing the lft button mouse
end;

{   Draw the selected tile on the screen,
    very simple function with out error control, the previus function
    must control it
}
procedure TMainForm.DrawTile;
begin
  undo_px := fix_px;
  undo_py := fix_py;
  undo_tile:= unit3.map.GetTile( fix_px, fix_py );
  Map.SetTile( fix_px, fix_py, selectedTile );
  ShowTerrain;
end;

{   Draw the sprite on the screen
}
procedure TMainForm.DrawSprite;
var
  tmpSprite : TSprite;
begin
  if lvSprites.Selected <> nil then
  begin
      //HTileW       := TileW div 2;
      //HTileH       := TileH div 2;

      tmpSprite       := TSprite.Create( selected_SpriteData );
      tmpSprite.X     := strtoint(StatusBar1.Panels[3].Text) ; //Coord. X;
      tmpSprite.Y     := strtoint(StatusBar1.Panels[5].Text) ; //Coord. Y;
      tmpSprite.BaseX := selected_SpriteData.FFrames[0].BaseOffset.x;
      tmpSprite.BaseY := selected_SpriteData.FFrames[0].BaseOffset.y;
      SpritesPos.FSpriteList.Add( tmpSprite );
      tmpSprite.Name  := TSpriteData(selected_SpriteData).Name + inttostr(SpritesPos.FSpriteList.Count );
      ShowTerrain;
      ShowSpritePositions;
  end;
end;

{   When clicking on the map go to the location
}
procedure TMainform.ShapeMapMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if ( Terrain = nil ) or ( Map = nil ) then exit;
  if Button = mbLeft then
  begin
    PosX := (x * Map.Width)  div ShapeMap.Width;
    PosY := (y * Map.Height) div ShapeMap.Height;
    ShowTerrain;
    MoveScaleMap;
  end;
end;

procedure TMainform.ShapeMapMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  //...
end;

{   Scroll...
}
procedure TMainform.ScrollBarVScroll(Sender: TObject;
  ScrollCode: TScrollCode; var ScrollPos: Integer);
begin
  if ( Terrain = nil ) or ( Map = nil ) then exit;

{  PosX := ScrollBarH.Position;
  PosY := ScrollBarV.Position;
  ShowTerrain;
  MoveScaleMap;}
end;

{   This is a must for a professional designer
}
procedure TMainform.btnUndoClick(Sender: TObject);
begin
  if ( Terrain = nil ) or ( Map = nil ) then exit;
  if undo_px <> -1 then
  begin
    unit3.map.settile( undo_px, undo_py, undo_tile );
    ShowTerrain;
  end;
end;

{   This refreshes all IDE objects
}
procedure TMainform.RefreshIDE;
var
  boolTerrain, boolMap : boolean;
begin
  if unit3.Terrain <> nil then  boolTerrain := True else boolTerrain := False;
  if unit3.Map <> nil     then  boolMap := True else boolMap := False;
  // Menus
  mnuOpenProject.Enabled     := boolTerrain;
  mnuSaveProject.Enabled     := boolMap;
  mnuCreateGlobalMap.Enabled := boolMap;
  // Buttons
  btnSave.Enabled            := boolMap;
  {btn1st.Enabled             := boolMap;
  btn2nd.Enabled             := boolMap;
  btn3rd.Enabled             := boolMap;
  btn4th.Enabled             := boolMap;}
  mnuEditSprite.Enabled      := boolMap;
  mnuEditTile.Enabled        := boolMap;
  btnEditSprite.Enabled      := boolMap;
  btnEditTile.Enabled        := boolMap;
  // Info Options
  cbShowSprites.Enabled      := boolMap;
  cbDebugTiles.Enabled       := boolMap;
end;

{   When we change the options on the info page, then
    we reflect the changes on the screen
}
procedure TMainform.cbRefreshClick(Sender: TObject);
begin
   ShowTerrain;
end;


{   Show the options
}
procedure TMainform.mnuOptionsClick(Sender: TObject);
begin
  frmOptions.ShowModal;
end;

{ Selects the sprites
}
procedure TMainform.lvSpritesSelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
  ShowSpritePositions;
end;

{ Selects the sprites position
}
procedure TMainform.lvSpritesPosSelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
begin
  if lvSpritesPos.Selected <> nil then
  begin
    FrmSpritePos.edLabel.Text := TSprite(SpritesPos.FSpriteList[ lvSpritesPos.selected.stateIndex]).Name;
    FrmSpritePos.edPosX.Text  := inttostr(TSprite(SpritesPos.FSpriteList[ lvSpritesPos.selected.stateIndex]).X);
    FrmSpritePos.edPosY.Text  := inttostr(TSprite(SpritesPos.FSpriteList[ lvSpritesPos.selected.stateIndex]).Y);
    FrmSpritePos.edPrior.Text := inttostr(lvSpritesPos.selected.stateIndex);
  end;
end;

procedure TMainform.btnPreviewClick(Sender: TObject);
begin
//  FrmDXTest := TFrmDXTest.Create( Application );
//  FrmDXTest.RunDXTest;
end;

{   This resizes all
}
procedure TMainform.FormResize(Sender: TObject);
var
 gh, ghp : integer;
begin
    // Resize controls
    //  Sprites controls
    gh := TabSheet_Sprites.Height;
    ghp:= (gh div 3);
    // 1
    lvSprites.Height     := ghp - 40;
    // 2
    PanelSpriteInfo2.Top := ghp + 2;
    lvSpritesPos.Top     := PanelSpriteInfo2.Top + 40;
    lvSpritesPos.Height  := ghp - 40;
    btnSpriteRight.Top   := PanelSpriteInfo2.Top + PanelSpriteInfo2.Height + 2;
    btnSpriteLeft.Top    := btnSpriteRight.Top;
    btnSpriteUp.Top      := btnSpriteRight.Top;
    btnSpriteDown.Top    := btnSpriteRight.Top;
    btnPriorityPlus.Top  := btnSpriteRight.Top;
    btnPriorityMin.Top   := btnSpriteRight.Top;
    btnSprProperties.Top := btnSpriteRight.Top;
    //btnNewSpritePos.Top  := PanelSpriteInfo2.Top + PanelSpriteInfo2.Height + 2;
    //posSpriteV.Top       := btnNewSpritePos.Top;
    //posSpriteH.Top       := btnNewSpritePos.Top;
    // 3
    PanelSpriteInfo3.Top := ((gh div 3) * 2) + 4;
    PanelSpritePrev.Top  := PanelSpriteInfo3.Top + 20;
    PanelSpritePrev.Height  := ghp - 30;
end;

procedure TMainform.SpeedButton1Click(Sender: TObject);
var
 Filename : string;
begin
  Filename := Terrain.Filename;
  Terrain.free;
  Terrain := TTerrain.create;
  CurrentPath := ExtractFilePath( Filename );
  Terrain.loadFromFile( ExtractFileName( Filename ) );
  ImageTiled.Picture.Bitmap := Terrain.Bmp;
  DessignScaleMap;
  RefreshIDE;
  if map <> nil then ShowTerrain;
end;

{   Change the edit mode, in tile or sprite
}
procedure TMainform.btnEditModeClick(Sender: TObject);
begin
  if (Sender = btnEditTile) or (Sender = mnuEditTile) then
  begin
    mnuEditTile.Checked := True;
    btnEditTile.Down    := True;
    plInfo.Caption      := 'Tile Information';
  end
  else
  begin
    mnuEditSprite.Checked := True;
    btnEditSprite.Down    := True;
    plInfo.Caption        := 'Sprite Information';
  end;
 fix_tx := -1;
end;


{   Only for debug, this makes faster to me to load
}
procedure TMainform.mnuDebugClick(Sender: TObject);
var
  s : string;
begin
 try
    prjFilename := 'c:\lenguajes\proyectos\mapeditor\tilesrle.map';
    Screen.Cursor := crHourGlass;
    CurrentPath := ExtractFilePath( prjFilename );
    s := ExtractFileName( prjFilename );
    if pos( '.', s ) > 0 then //toglie estensione
      s := copy( s, 1, pos( '.', s ) - 1 );
    if not FileExists( s + '.tls' ) then
    begin
        ShowMessage( s + '.tls doesn''t exist !' );
        exit;
    end;
    if not FileExists( s + '.map' ) then
    begin
        ShowMessage( s + '.map doesn''t exist !' );
        exit;
    end;
    Terrain.free;
    Terrain := TTerrain.create;
    Terrain.loadFromFile( s + '.tls' );
    ImageTiled.picture.Bitmap := Terrain.Bmp;
    // Open Map
    Screen.Cursor := crHourGlass;
    Map.free;
    Map := TMap.create;
    Map.loadFromFile( s + '.map' );

    // Open NEW Sprite positios
    Screen.Cursor := crHourGlass;
    SpritesPos.Free;
    if FileExists( s + '.pos' ) then
    begin
        SpritesPos := TSprites.Create;
        SpritesPos.LoadFromFile( s + '.pos' );
        ShowSpritesinWindow;
    end;
    DessignScaleMap;
    Screen.Cursor := crHourGlass;
    ShowTerrain;
  finally
    RefreshIDE;
    Screen.Cursor := crDefault;
  end;
end;

procedure TMainform.btnRefreshClick(Sender: TObject);
begin
     ShowTerrain;
end;

{   Show the sprites in memory on the windows from select
}
procedure TMainform.ShowSpritesinWindow;
var
  li : TListItem;
  f, n : integer;
  add : boolean;
begin
  lvSprites.Visible := False;
  lvSprites.Items.Clear;
  for f := 0 to SpritesPos.FSpriteDataList.Count - 1 do
  begin
    add := True;
    for n := 0 to lvSprites.Items.Count - 1 do
      if lvSprites.Items[n].Caption = ExtractFileName(TSpriteData(SpritesPos.FSpriteDataList[f]).FileName) then
           add := False;
    if add then
    begin
      li := lvSprites.Items.Add;
      li.Caption := ExtractFileName(TSpriteData(SpritesPos.FSpriteDataList[f]).FileName);
    end;
  end;
  lvSprites.Visible := True;
end;

{   From the stored sprites in memory get all the sprites that belongs with
}
procedure TMainform.ShowSpritePositions;
var
  li : TListItem;
  f, n, spr_width, spr_height, px, py : integer;
  add : boolean;
begin
  with mainform do
  begin
    lvSpritesPos.Items.Clear;
    if lvSprites.Selected = nil then exit;
    for f := 0 to SpritesPos.FSpriteList.Count - 1 do
    begin
      if uppercase(lvSprites.Selected.Caption) =
         uppercase(ExtractFileName(TSprite(SpritesPos.FSpriteList[f]).FSpriteData.FileName) ) then
      begin
        li := lvSpritesPos.Items.Add;
        li.Caption := TSprite(SpritesPos.FSpriteList[f]).Name;                             // Name
        li.SubItems.Add( inttostr(TSprite(SpritesPos.FSpriteList[f]).X) );                 // X
        li.SubItems.Add( inttostr(TSprite(SpritesPos.FSpriteList[f]).Y) );                 // Y
        li.stateIndex := f;                                                                // ID
      end;
    end;
    // Show the graphic
    for f := 0 to SpritesPos.FSpriteDataList.Count - 1 do
    begin
      if uppercase(lvSprites.Selected.Caption) =
         uppercase(ExtractFileName(TSpriteData(SpritesPos.FSpriteDataList[f]).FileName) ) then
      begin
         CurrSpriteImage.canvas.FillRect( Rect( 0, 0, mainform.CurrSpriteImage.width, mainform.CurrSpriteImage.height ) );
         with TFrame(TSpriteData(SpritesPos.FSpriteDataList[f]).FFrames[0]) do
         begin
           spr_width  := FRect.Right - FRect.Left;
           spr_Height := FRect.Bottom - FRect.Top;
           PX         := (CurrSpriteImage.Width - spr_width) div 2;
           PY         := (CurrSpriteImage.Height - spr_height) div 2;
           CurrSpriteImage.canvas.BrushCopy( Rect( PX, PY, PX + spr_width, PY + spr_height ),BitMap, FRect, clWhite );
         end;
         selected_SpriteData := TSpriteData(SpritesPos.FSpriteDataList[f]);
         break;
      end;
    //bmp.free;
    end;
  end;
end;

{   Loads new sprites on memory
}
procedure TMainform.btnNewSpriteClick(Sender: TObject);
var
  tmpStr : string;
  tmpSpriteData : TSpriteData;
begin
  with OpenDialog do
  begin
    DefaultExt := 'spr';
    Filter := 'Sprite files (*.spr)|*.spr';
    if Execute then
    begin
      tmpStr := '.\' + ExtractRelativePath( MainForm.CurrentPath, Filename ); //ExtractFileName(Filename);
      tmpSpriteData := SpritesPos.LoadSpriteData( FileName );
      ShowSpritesinWindow;
    end;
  end;
  MainForm.showTerrain;
end;


procedure TMainform.btnSpritePosClick(Sender: TObject);
begin
  if lvSpritesPos.selected <> nil then
  begin
    if Sender = btnSpriteRight then
       TSprite(SpritesPos.FSpriteList[ lvSpritesPos.selected.stateIndex]).X  :=
              TSprite(SpritesPos.FSpriteList[ lvSpritesPos.selected.stateIndex]).X + 1;
    if Sender = btnSpriteLeft then
       TSprite(SpritesPos.FSpriteList[ lvSpritesPos.selected.stateIndex]).X  :=
              TSprite(SpritesPos.FSpriteList[ lvSpritesPos.selected.stateIndex]).X - 1;
    if Sender = btnSpriteUp then
       TSprite(SpritesPos.FSpriteList[ lvSpritesPos.selected.stateIndex]).Y  :=
              TSprite(SpritesPos.FSpriteList[ lvSpritesPos.selected.stateIndex]).Y - 1;
    if Sender = btnSpriteDown then
       TSprite(SpritesPos.FSpriteList[ lvSpritesPos.selected.stateIndex]).Y  :=
              TSprite(SpritesPos.FSpriteList[ lvSpritesPos.selected.stateIndex]).Y + 1;
    lvSpritesPos.selected.SubItems[0] := inttostr( TSprite(SpritesPos.FSpriteList[ lvSpritesPos.selected.stateIndex]).X );
    lvSpritesPos.selected.SubItems[1] := inttostr( TSprite(SpritesPos.FSpriteList[ lvSpritesPos.selected.stateIndex]).Y );
    ShowTerrain;
  end;
end;

{ Change Priority to one more
}
procedure TMainform.btnPriorityPlusClick(Sender: TObject);
begin
  if lvSpritesPos.selected <> nil then
  begin
     if SpritesPos.FSpriteList.Count <= lvSpritesPos.selected.stateIndex+1 then exit;
     SpritesPos.FSpriteList.Exchange(lvSpritesPos.selected.stateIndex, lvSpritesPos.selected.stateIndex+1);
     // Reload sprites
     ShowSpritePositions;
     ShowTerrain;
  end;
end;

{ Change Priority to one lower
}
procedure TMainform.btnPriorityMinClick(Sender: TObject);
begin
  if lvSpritesPos.selected <> nil then
  begin
     if lvSpritesPos.selected.stateIndex = 0 then exit;
     SpritesPos.FSpriteList.Exchange(lvSpritesPos.selected.stateIndex, lvSpritesPos.selected.stateIndex-1);
     // Reload sprites
     ShowSpritePositions;
     ShowTerrain;
  end;
end;

{   DIRECT X
    TileSurface: TDirectDrawSurface;
}

procedure TMainform.DXDrawInitializeSurface(Sender: TObject);
begin
  TileSurface := TDirectDrawSurface.Create(DXDraw.DDraw);
  TileSurface.SetSize(DXDraw.Width, DXDraw.Height );
  TileSurface.Fill(0);
  DXDraw.Primary.GammaControl.GetGammaRamp(0, FDefaultGammaRamp);      // get default gamma
  DXTimer1.Enabled   := True;
end;

procedure TMainform.DXDrawFinalizeSurface(Sender: TObject);
begin
  DXTimer1.Enabled := False;
  FSurface.Free;
  TileSurface.Free;
end;

procedure TMainform.DXTimer1Timer(Sender: TObject; LagCount: Integer);
begin
  if not DXDraw.CanDraw then Exit;
  DXDraw.UpdatePalette;
  DXDraw.Surface.Fill(0);

  if Terrain <> nil then
  begin
     DXDraw.Surface.Draw(0,0,TileSurface,False);
     {DXDraw.Surface.DrawAlpha( Rect(0,0,DXDraw.Width, DXDraw.Height),
                               Rect(0,0,TileSurface.Width,TileSurface.Height),TileSurface,False, 99);
     }
  end;
  //BitBlt( Mainform.image.canvas.handle, 0, 0, 40, 20, DXDraw.Surface.canvas.handle, 10, 10, SRCCopy );

  {with DXDraw.Surface.Canvas do
  begin
    Brush.Style := bsClear;
    Font.Color := clWhite;
    Font.Size := 10;
    Textout(0, 0, 'FPS: '+inttostr(DXTimer1.FrameRate));
    //Textout(0, 20, 'KEY: '+inttostr(LastKey));

    Release; {  Indispensability  }
  {end;}
  StatusBar1.Panels[13].Text := inttostr(DXTimer1.FrameRate);

  TileMouseMove( LastX, LastY );

  DXDraw.Flip;
end;


procedure TMainform.btnSprPropertiesClick(Sender: TObject);
begin
  FrmSpritePos.Show;
end;

procedure TMainform.UpDownGammaClick(Sender: TObject; Button: TUDBtnType);
var
  GammaRamp: TDDGammaRamp;
  i, n: Integer;
begin
  n := UpDownGamma.Position * 10;
  for i:=0 to 255 do
  begin
    GammaRamp.Red[i]   := FDefaultGammaRamp.Red[i] + n;
    GammaRamp.Green[i] := FDefaultGammaRamp.Green[i] + n;
    GammaRamp.Blue[i]  := FDefaultGammaRamp.Blue[i] + n;
  end;

  DXDraw.Primary.GammaControl.SetGammaRamp(0, GammaRamp);
end;

end.
