unit UOptions;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, registry;

type
  TfrmOptions = class(TForm)
    Panel1: TPanel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    GroupBox1: TGroupBox;
    Panel8: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    RadioGroup1: TRadioGroup;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Label4: TLabel;
    Edit1: TEdit;
    UpDown1: TUpDown;
    Label5: TLabel;
    Edit2: TEdit;
    UpDown2: TUpDown;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    bntOK: TButton;
    btnCancel: TButton;
    CheckBox3: TCheckBox;
    ColorDialog1: TColorDialog;
    TabSheet5: TTabSheet;
    GroupBox2: TGroupBox;
    Panel2: TPanel;
    btnclDebugTile: TButton;
    btnclDebugSprite: TButton;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    clDebugTile: TPanel;
    clDebugSprite: TPanel;
    Panel9: TPanel;
    procedure btnChangeColorClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmOptions: TfrmOptions;
  dir_path : string;
  procedure LoadConfigurations;
  procedure SaveConfigurations;

implementation

{$R *.DFM}

{   Loads all configurations
}
procedure LoadConfigurations;
var
  MapEditorReg : TRegIniFile;
begin
    MapEditorReg := TRegIniFile.create('Software\MapEditor');
    with MapEditorReg, frmOptions do
    begin
       { Directories }
       WriteString('Directories', 'AppRun', ParamStr(0));                    // Fichero que ejecutar el checkmail
       dir_path     := ExtractFileDir(ParamStr(0))+'\';  //'C:\'+AppName+'\';
       dir_path     := ReadString('Directories', 'path',     dir_path);
       clDebugTile.Color := ReadInteger('Colors', 'DebugTile', clBlack);
       clDebugSprite.Color := ReadInteger('Colors', 'DebugSprite', clWhite);
    end;
    MapEditorReg.Free;
 end;

{   Saves it all
}
procedure SaveConfigurations;
begin

end;

procedure TfrmOptions.btnChangeColorClick(Sender: TObject);
begin
   // Debug Tile
   if (Sender = btnclDebugTile) or (Sender = clDebugTile) then
   begin
      ColorDialog1.Color := clDebugTile.Color;
      if ColorDialog1.Execute then
            clDebugTile.Color := ColorDialog1.Color;
   end;
   // Debug Sprite
   if (Sender = btnclDebugSprite) or (Sender = clDebugSprite) then
   begin
      ColorDialog1.Color := clDebugSprite.Color;
      if ColorDialog1.Execute then
            clDebugSprite.Color := ColorDialog1.Color;
   end;
end;

end.
