unit USpriteProperties;

// Code tidied by Dominique Louis November 1999

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, unit3, ComCtrls, ColorGrd;

type
  TSpriteDialog = class( TForm )
    Panel1 : TPanel;
    BitBtn1 : TBitBtn;
    Button1 : TButton;
    Panel4: TPanel;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    GroupBox1: TGroupBox;
    cbLR: TCheckBox;
    cbTD: TCheckBox;
    cbR90: TCheckBox;
    lvFrames: TListView;
    GroupBox2: TGroupBox;
    X: TLabel;
    Label1: TLabel;
    edOY: TEdit;
    edOX: TEdit;
    UpDown1: TUpDown;
    UpDown2: TUpDown;
    Label3: TLabel;
    Label2: TLabel;
    edH: TEdit;
    edW: TEdit;
    UpDown4: TUpDown;
    UpDown3: TUpDown;
    Label4: TLabel;
    Label5: TLabel;
    edBY: TEdit;
    edBX: TEdit;
    UpDown5: TUpDown;
    UpDown6: TUpDown;
    Edit7: TEdit;
    Label6: TLabel;
    UpDown7: TUpDown;
    Panel2: TPanel;
    ScrollBox2: TScrollBox;
    ImageSprite: TImage;
    Hline: TShape;
    Vline: TShape;
    Panel3: TPanel;
    Shape1: TShape;
    Shape2: TShape;
    ShapeBasePoint: TShape;
    SpeedButton2: TSpeedButton;
    SpeedButton1: TSpeedButton;
    Label8: TLabel;
    ZoomB1: TSpeedButton;
    ZoomB2: TSpeedButton;
    ZoomB3: TSpeedButton;
    Panel5: TPanel;
    Label9: TLabel;
    Label10: TLabel;
    btnAddFrame: TSpeedButton;
    btnDelFrame: TSpeedButton;
    Edit9: TEdit;
    Label7: TLabel;
    Splitter1: TSplitter;
    ColorGrid1: TColorGrid;
    procedure BitBtn1Click( Sender : TObject );
    procedure BtnDeleteFrame( Sender : TObject );
    procedure SpeedButton5Click( Sender : TObject );
    procedure Image1MouseUp( Sender : TObject; Button : TMouseButton;
      Shift : TShiftState; X, Y : Integer );
    procedure ZoomBClick( Sender : TObject );
    procedure UpDownClick( Sender : TObject; Button : TUDBtnType );
    procedure SpeedButton1Click( Sender : TObject );
    procedure SpeedButton2Click( Sender : TObject );
    procedure FormCreate(Sender: TObject);
    procedure ImageSpriteMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ImageSpriteMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ImageSpriteMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure lvFramesSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure btnAddFrameClick(Sender: TObject);
    procedure edOXChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    zoom : integer;
    procedure InsertSprite( Anim, PrevFrameID : string );
    procedure ConfirmSpriteValues;
    procedure Delete( FId : string );
    procedure EditSprite( FrameID : integer );
    procedure RefreshImage;
    procedure LoadFrames;

  end;

var
  SpriteDialog : TSpriteDialog;

implementation

uses UMain, USprites;

{$R *.DFM}

procedure TSpriteDialog.FormCreate(Sender: TObject);
begin
  shape1.visible := false;
  Hline.visible := true;
  Vline.visible := true;
  zoom := 1;
  Image1.canvas.Brush.Style := bsSolid;
  Image1.canvas.Brush.Color := clWhite;
  ImageSprite.Canvas.Brush  := Image1.canvas.Brush;
end;

procedure TSpriteDialog.BitBtn1Click( Sender : TObject );
begin
  confirmSpriteValues;
  close;
end;

procedure TSpriteDialog.BtnDeleteFrame( Sender : TObject );
begin
  Delete( edit9.text );
end;

procedure TSpriteDialog.InsertSprite( Anim, PrevFrameID : string );
var
  s : string;
  fx, pins, prev, k, j : integer;
begin
// crea lo spazio (cioe' i campi vuoti) per il frame
  Screen.Cursor := crHourGlass;
  with unit3.SpriteList do
  begin
    if PrevFrameID = 'None' then //ultimo frame di un'animazione
    begin
      edit9.text := '0'; // alla peggio parte da 0
      pins := indexOf( 'Animation=' + Anim ) + 2; //inizio animazione (+2 per essere dopo il bmp)
      if pins < 0 then
      begin
        ShowMessage( 'Animation does not exist!' );
        exit;
      end;
      for k := pins to Count - 1 do
      begin
        s := Strings[ k ];
        if ( copy( s, 1, 9 ) = 'Animation' ) then //trovato l'anim successivo
        begin
          pins := k; // inizia subito prima
          break;
        end;
      end;
      prev := SpriteForm.FindFieldSF( 'NF' ); //fine dati generali
      for k := pins - 1 downto prev do
      begin
        s := Strings[ k ];
        if copy( s, 1, 2 ) = 'ID' then //trovato l'ID precedente
        begin
          s := copy( s, 4, length( s ) ); //prende il valore
          edit9.text := inttostr( 1 + strtoint( s ) ); // lo incrementa
          break;
        end;
      end;
    end
    else // veramente non funziona...
    begin
      prev := indexOf( 'ID=' + PrevFrameID ); //cerca il frame precedente
      pins := Count; // alla peggio aggiunge alla fine
      for k := prev + 1 to Count - 1 do // prev+1 se no riprende lo stesso
      begin
        s := Strings[ k ];
        if ( copy( s, 1, 2 ) = 'ID' ) or ( copy( s, 1, 9 ) = 'Animation' ) then //trovato l'ID o l'anim successivo
        begin
          pins := k;
          break;
        end;
      end;
      edit9.text := inttostr( 1 + strtoint( PrevFrameID ) );
    end;

    for k := strtoint( SpriteForm.ReadSF( 'NF' ) ) - 1 downto strtoint( edit9.text ) do //aggiorna gli altri ID
    begin
      s := inttostr( k );
      j := IndexOf( 'ID=' + s );
      if j > 0 then
        Strings[ j ] := 'ID=' + inttostr( 1 + k ); // aggiunge 1
    end;

    s := SpriteForm.ReadSF( 'NF' );
    s := inttostr( 1 + strtoint( s ) );
    SpriteForm.writeSF( 'NF', s ); // aggiorna NF

    Insert( pins, 'ID=' + edit9.text ); //inizia ad inserire i dati
    Insert( pins + 1, 'OX=' + edOX.text );
    Insert( pins + 2, 'OY=' + edOY.text );
    Insert( pins + 3, 'W=' + edW.text );
    Insert( pins + 4, 'H=' + edH.text );
    Insert( pins + 5, 'BX=' + edBX.text );
    Insert( pins + 6, 'BY=' + edBY.text );
    Insert( pins + 7, 'D=' + edit7.text );
    fx := 0;
    if cbLR.checked then fx := 2;
    if cbTD.checked then fx := fx + 4;
    Insert( pins + 8, 'FX=' + inttostr( fx ) );
    Insert( pins + 9, ';' );
    // Actualizar las listas!!
    Spriteform.SetAnimation( Anim );    // Reload on memory
    LoadFrames;                         // Show it
  end; //with

  Screen.Cursor := crDefault;
  RefreshImage;

end;

procedure TSpriteDialog.confirmSpriteValues;
var
  k : integer;
  fx : integer;
begin
// cerca l'ID e modifica i valori
  with unit3.SpriteList do
  begin
    k := indexOf( 'ID=' + edit9.text ); //cerca il frame attuale
    if k < 0 then
    begin
      showMessage( 'Wrong ID' );
      exit;
    end;
    Strings[ k + 1 ] := 'OX=' + edOX.text;
    Strings[ k + 2 ] := 'OY=' + edOY.text;
    Strings[ k + 3 ] := 'W=' + edW.text;
    Strings[ k + 4 ] := 'H=' + edH.text;
    Strings[ k + 5 ] := 'BX=' + edBX.text;
    Strings[ k + 6 ] := 'BY=' + edBY.text;
    Strings[ k + 7 ] := 'D=' + edit7.text;
    fx := 0;
    if cbLR.checked then fx := 2;
    if cbTD.checked then fx := fx + 4;
    Strings[ k + 8 ] := 'FX=' + inttostr( fx );

    SpriteForm.pnID.caption := edit9.text;
    SpriteForm.pnNF.caption := SpriteForm.ReadSF( 'NF' );
  end; //with

end;

procedure TSpriteDialog.Delete( FId : string );
var
  k, j : integer;
begin
  if lvFrames.Selected = nil then exit;
  Screen.Cursor := crHourGlass;
// cerca l'ID e modifica i valori
  with unit3.SpriteList do
  begin
    k := indexOf( 'ID=' + FId ); //cerca il frame attuale
    if k < 0 then
    begin
      showMessage( 'Wrong ID' );
      exit;
    end;
    for j := 0 to 7 do // 7 righe da cancellare
      delete( k ); /// sette volte la stessa (basta pensarci un po')

  /// abbassa tutti gli ID successivi
    for k := strtoint( FId ) + 1 to strtoint( SpriteForm.ReadSF( 'NF' ) ) - 1 do //aggiorna gli altri ID
    begin
      j := IndexOf( 'ID=' + inttostr( k ) );
      if j > 0 then
        Strings[ j ] := 'ID=' + inttostr( k - 1 ); // abbassa di 1
    end;

  end; // with

  SpriteForm.WriteSF( 'NF', inttostr( strtoint( SpriteForm.ReadSF( 'NF' ) ) - 1 ) ); // abbassa NF

  SpriteForm.pnID.caption := 'None';
  SpriteForm.pnNF.caption := SpriteForm.ReadSF( 'NF' );

  // Actualizar las listas!!
  Spriteform.SetAnimation( SpriteForm.lvAnimations.Selected.Caption );    // Reload on memory
  LoadFrames;                         // Show it
  Screen.Cursor := crDefault;
end;


procedure TSpriteDialog.EditSprite( FrameID : integer );
var
  CurrFrame : TFrameOld;
  fx, k : integer;
begin
    if Spriteform.AnimFrameLst.Count = 0 then exit;                   // Not defined

    CurrFrame := Spriteform.AnimFrameLst[ FrameID ];

    edit9.text := inttostr( CurrFrame.ID ); // ID=
    edOX.text := inttostr( CurrFrame.OX ); // OX=
    edOY.text := inttostr( CurrFrame.OY ); // OY=
    edW.text := inttostr( CurrFrame.W  ); // W=
    edH.text := inttostr( CurrFrame.H  ); // H=
    edBX.text := inttostr( CurrFrame.BX ); // BX=
    edBY.text := inttostr( CurrFrame.BY ); // BY=
    edit7.text := inttostr( CurrFrame.D  ); // D=
    {if not ( copy( Strings[ k + 8 ], 1, 3 ) = 'FX=' ) then //vecchio formato
      Insert( k + 8, 'FX=0' );
    fx := strtoint( copy( Strings[ k + 8 ], 4, 100 ) ); // FX=
    cbLR.checked := ( fx and 2 ) = 2;
    cbTD.checked := ( fx and 4 ) = 4;}

    RefreshImage;
    SpriteForm.pnID.caption := edit9.text;
    SpriteForm.pnNF.caption := SpriteForm.ReadSF( 'NF' );
end;

procedure TSpriteDialog.RefreshImage;
var
  CurrFrame : TFrameOld;
  k, cx, cy, start : integer;
begin
  if lvFrames.Selected = nil then exit;

  CurrFrame := Spriteform.AnimFrameLst[ lvFrames.Selected.Index ];

  cx := Image1.width div 2;
  cy := Image1.height div 2;

  Image1.canvas.FillRect( Rect(0, 0, Image1.width, Image1.height) ); //cls
  //canvas.rectangle( 0, 0, width, height );
  BitBlt( Image1.canvas.handle, cx - CurrFrame.BX, cy - CurrFrame.BY, CurrFrame.W, CurrFrame.H,
            SpriteDialog.ImageSprite.canvas.handle, CurrFrame.OX, CurrFrame.OY, SRCCOPY );
  // Seleted Sprite
  Shape2.Left    := CurrFrame.OX;
  Shape2.Top     := CurrFrame.OY;
  Shape2.Height  := CurrFrame.H;
  Shape2.Width   := CurrFrame.W;
  Shape2.Visible := True;
  // Base Point
  ShapeBasePoint.Left := CurrFrame.OX - CurrFrame.BX;
  ShapeBasePoint.Top  := CurrFrame.OY - CurrFrame.BY;
  // Update the image
  Image1.Update;
end;


procedure TSpriteDialog.SpeedButton5Click( Sender : TObject );
begin
  confirmSpriteValues;
  RefreshImage;
end;

procedure TSpriteDialog.Image1MouseUp( Sender : TObject;
  Button : TMouseButton; Shift : TShiftState; X, Y : Integer );
begin
  edOX.text := inttostr( X div zoom );
  edOY.text := inttostr( Y div zoom );
end;

procedure TSpriteDialog.ZoomBClick( Sender : TObject );
begin
  RefreshImage;
end;

procedure TSpriteDialog.UpDownClick( Sender : TObject; Button : TUDBtnType );
begin
  if lvFrames.Selected = nil then exit;

  with TFrameOld(Spriteform.AnimFrameLst[ lvFrames.Selected.Index ]) do
  begin
    OX := strtoint(edOX.text);
    OX := strtoint(edOY.text);
    W  := strtoint(edW.text);
    H  := strtoint(edH.text);
    BX := strtoint(edBX.text);
    BY := strtoint(edBY.text);
    RefreshImage;
  end;
end;

procedure TSpriteDialog.edOXChange(Sender: TObject);
begin
  if TEdit(Sender).Text = '' then exit;
  UpDownClick( Sender , btNext );
end;

procedure TSpriteDialog.SpeedButton1Click( Sender : TObject );
begin
//  edit1.Text := inttostr( strtoint( edit4.text ) - strtoint( edit1.text ) + 1 );
  MessageBeep( 0 );

end;

procedure TSpriteDialog.SpeedButton2Click( Sender : TObject );
begin
//  edit6.Text := inttostr( strtoint( edit5.text ) - strtoint( edit6.text ) + 1 );
  MessageBeep( 0 );

end;

(* occorre editare i valori base dello sprite*)

//******************************************************************************
// New functions by John Lohmeyer 17/08/2000

procedure TSpriteDialog.ImageSpriteMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
  sbv, sbh : integer;
begin
  sbv := {ScrollBox1.VertScrollBar.position} -ImageSprite.Top;
  sbh := {ScrollBox1.HorzScrollBar.position} -ImageSprite.Left;
//  if crosslines1.checked then
//  begin
    Vline.SetBounds( ( ( X - sbh ) div zoom ) * zoom, ( ( Y - sbv + 10 ) div zoom ) * zoom, 1, ImageSprite.height - Y + sbv - 10 );
    if not Vline.visible then Vline.visible := true;
    Hline.SetBounds( ( ( X - sbh + 10 ) div zoom ) * zoom, ( ( Y - sbv ) div zoom ) * zoom, ImageSprite.width - X + sbh - 10, 1 );
    if not Hline.visible then Hline.visible := true;
//  end;
  if shape1.visible then
  begin
    shape1.width := ( ( X - shape1.left - sbh ) div zoom ) * zoom;
    shape1.height := ( ( Y - shape1.top - sbv ) div zoom ) * zoom;
  end;
  Shape2.Visible := False;
//  StatusBar1.Panels.Items[ 1 ].Text := inttostr( X div zoom );
//  StatusBar1.Panels.Items[ 3 ].Text := inttostr( Y div zoom );
end;

procedure TSpriteDialog.ImageSpriteMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  sbh, sbv : integer;
begin
  sbh := {ScrollBox1.HorzScrollBar.position} -ImageSprite.Left;
  sbv := {ScrollBox1.VertScrollBar.position} -ImageSprite.Top;
  shape1.SetBounds( ( ( X - sbh ) div zoom ) * zoom, ( ( Y - sbv ) div zoom ) * zoom, 0, 0 );
  shape1.visible := true;
end;

procedure TSpriteDialog.ImageSpriteMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  sbh, sbv : integer;
begin
  sbh := {ScrollBox1.HorzScrollBar.position} -ImageSprite.Left;
  sbv := {ScrollBox1.VertScrollBar.position} -ImageSprite.Top;
  if not shape1.visible then
  begin
    shape1.SetBounds( 0, 0, ( ( X - sbh ) div zoom ) * zoom, ( ( Y - sbv ) div zoom ) * zoom );
  end
  else
  begin
    shape1.width := ( ( X - shape1.left - sbh ) div zoom ) * zoom;
    shape1.height := ( ( Y - shape1.top - sbv ) div zoom ) * zoom;
  end;
  shape1.visible := false;
  SpriteDialog.edOX.text := inttostr( ( shape1.left + sbh ) div zoom );
  SpriteDialog.edOY.text := inttostr( ( shape1.top + sbv ) div zoom );
  SpriteDialog.edW.text := inttostr( shape1.width div zoom );
  SpriteDialog.edH.text := inttostr( shape1.height div zoom );
  SpriteDialog.edit7.text := '5'; // default duration of animation

  SpriteDialog.InsertSprite( SpriteForm.lvAnimations.Selected.Caption, 'None' ); ///pnID.caption);// il none e' per inserirla come ultima
  LoadFrames;
end;

//******************************************************************************
// New functions by John Lohmeyer 17/08/2000

procedure TSpriteDialog.LoadFrames;
var
 CurrFrame : TFrameOld;
 ti : TListItem;
 f  : integer;
begin
 lvFrames.Items.Clear;
 if Spriteform.AnimFrameLst.Count = 0 then exit;                   // Not defined

 for f := 0 to Spriteform.AnimFrameLst.Count - 1 do
 begin
    CurrFrame := Spriteform.AnimFrameLst[ f ];
    ti := lvFrames.Items.Add;
    ti.Caption := inttostr(CurrFrame.ID);
    ti.SubItems.Add( inttostr(CurrFrame.OX) );          // OX
    ti.SubItems.Add( inttostr(CurrFrame.OY) );          // OY
    ti.SubItems.Add( inttostr(CurrFrame.W) );           // W
    ti.SubItems.Add( inttostr(CurrFrame.H) );           // H
 end;
end;

procedure TSpriteDialog.lvFramesSelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
begin
  EditSprite( Item.Index );
end;

procedure TSpriteDialog.btnAddFrameClick(Sender: TObject);
begin
   ShowMessage('Select the portion to add on the bitmap window');
end;


end.
