unit USprites;

// Code tidied by Dominique Louis November 1999

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ExtCtrls, Menus, Buttons, StdCtrls;

type
  TBmpFrame = class
    Rect : TRect;
    Center : TPoint;
  end;

  TSpriteForm = class( TForm )
    MainMenu1 : TMainMenu;
    File1 : TMenuItem;
    New1 : TMenuItem;
    Open1 : TMenuItem;
    Save1 : TMenuItem;
    N1 : TMenuItem;
    Exit1 : TMenuItem;
    Edit1 : TMenuItem;
    Text1 : TMenuItem;
    Image1 : TMenuItem;
    LoadBMP1 : TMenuItem;
    Sprite1 : TMenuItem;
    Clear1 : TMenuItem;
    N5 : TMenuItem;
    DetectCircle1 : TMenuItem;
    CollisionCircle1 : TMenuItem;
    Frame1 : TMenuItem;
    Add1 : TMenuItem;
    Edit2 : TMenuItem;
    Delete1 : TMenuItem;
    Animation1 : TMenuItem;
    Add2 : TMenuItem;
    Import1 : TMenuItem;
    btnAddAnim: TSpeedButton;
    lvAnimations: TListView;
    Label3: TLabel;
    Label2: TLabel;
    lvVars: TListView;
    btnAddFrame: TSpeedButton;
    Bevel1: TBevel;
    btnProperties: TSpeedButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    btnDeleteFrame: TSpeedButton;
    btnEditFrame: TSpeedButton;
    btnNewFrame: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton1: TSpeedButton;
    btnStopAnim: TSpeedButton;
    btnPlayAnim: TSpeedButton;
    Label1: TLabel;
    Label4: TLabel;
    pnID: TPanel;
    Panel4: TPanel;
    imFrame: TImage;
    pnNF: TPanel;
    Panel1: TPanel;
    Panel2: TPanel;
    ImageFrame1: TImage;
    Panel3: TPanel;
    ImageFrame2: TImage;
    Panel5: TPanel;
    ImageFrame3: TImage;
    btnOpen: TSpeedButton;
    btnSave: TSpeedButton;
    ScrollBox1: TScrollBox;
    ImageBMP: TImage;
    procedure New1Click( Sender : TObject );
    procedure FormCreate( Sender : TObject );
    procedure FormCloseQuery( Sender : TObject; var CanClose : Boolean );
    procedure Open1Click( Sender : TObject );
    procedure Save1Click( Sender : TObject );
    procedure Exit1Click( Sender : TObject );
    procedure Text1Click( Sender : TObject );
    procedure btnNewFrameClick( Sender : TObject );
    procedure Add1Click( Sender : TObject );
    procedure btnPlayAnimClick( Sender : TObject );
    procedure btnStopAnimClick( Sender : TObject );
    procedure btnEditFrameClick( Sender : TObject );
    procedure Edit2Click( Sender : TObject );
    procedure btnDeleteFrameClick( Sender : TObject );
    procedure Delete1Click( Sender : TObject );
    procedure SpeedButton2Click( Sender : TObject );
    procedure SpeedButton1Click( Sender : TObject );
    procedure Add2Click( Sender : TObject );
    procedure btnAddAnimationClick( Sender : TObject );
    procedure NAnimationClick( Sender : TObject );
    procedure Import1Click( Sender : TObject );
    procedure lvAnimationsSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure FormDestroy(Sender: TObject);
  private
  { Private declarations }
    procedure NoFrameSelected;

  public
  { Public declarations }
    zoomimage : integer;
    LeftImage, TopImage : integer;  // Position of the image
    FLMode : ( mdStop, mdLoop, mdForward, mdBack, mdEnd );
    AnimFrameLst : TList; // Global var it contains the animation frame list
    procedure OpenSpriteFile( FileName : string );
    function  ReadSF( S : string ) : string;
    function  FindFieldSF( S : string ) : integer;
    procedure WriteSF( S, S2 : string );
    procedure SetAnimationImage( Anim : string );
    procedure SetAnimation( AnimName : string );
    function  CountFrameAnim( NameAnim : string ) : integer;      // Count number of frames
    procedure DessignAnimation( Frame : integer );
  end;

const
  sprTitle = 'Sprite editor';

var
  SpriteForm : TSpriteForm;

implementation

uses UMain, UTextEditor, UNewSprite, Unit3, USpriteProperties;

{$R *.DFM}

procedure TSpriteForm.FormCreate( Sender : TObject );
begin
  AnimFrameLst := TList.Create;
  FLMode       := mdEnd;
  zoomimage    := 1;
  // Assign some stuff to default
  imFrame.canvas.Brush.Style := bsSolid;
  imFrame.canvas.Brush.Color := clWhite;
  ImageFrame1.canvas.Brush := imFrame.canvas.Brush;
  ImageFrame2.canvas.Brush := imFrame.canvas.Brush;
  ImageFrame3.canvas.Brush := imFrame.canvas.Brush;
end;

{   Free all memory
}
procedure TSpriteForm.FormDestroy(Sender: TObject);
var
  k : integer;
  CurrFrame : TFrameOld;
begin
  // Delete all
  for k := 0 to AnimFrameLst.count - 1 do
  begin
    CurrFrame := AnimFrameLst[ k ];
    CurrFrame.free;
  end;
  AnimFrameLst.Free;
end;

procedure TSpriteForm.New1Click( Sender : TObject );
begin
  Caption := sprTitle + ' - Not Yet Saved';
  NewSprites.showmodal;
end;


procedure TSpriteForm.FormCloseQuery( Sender : TObject; var CanClose : Boolean );
begin
  mainform.sprites1.checked := false;
  if btnStopAnim.enabled then btnStopAnimClick( self );
end;

procedure TSpriteForm.OpenSpriteFile( FileName : string );
var
  k,j: integer;
  ti : TListItem;
  s  :  string;
begin
  if FileName <> '' then
  begin
    SpriteList.LoadFromFile( Filename );
 // non serve piu' col nuovo formato// ImageSprite.picture.LoadFromFile(ReadSF('Image'));
    lvAnimations.Items.Clear;          // Clear all items in the animation list
    for k := 0 to unit3.SpriteList.Count - 1 do // carica le animazioni definite
      if ( copy( unit3.SpriteList.Strings[ k ], 1, 9 ) = 'Animation' ) then //un anim da caricare
      begin
        ti := lvAnimations.Items.Add;
        s  := copy( SpriteList.Strings[ k ], 11, 100 );
        ti.Caption := s;
        ti.SubItems.Add( inttostr( CountFrameAnim( s ) ) );
      end;

    // Add Variables
    lvVars.Items.Clear;
    k := 0;
    while k < unit3.SpriteList.Count - 1 do // carica le animazioni definite
    begin
      if ( copy( unit3.SpriteList.Strings[ k ], 1, 9 ) = 'Animation' ) then
            break;                  // Exit;
      if unit3.SpriteList.Strings[ k ][ 1 ] <> ';' then
      begin
        ti := lvVars.Items.Add;
        s  := SpriteList.Strings[ k ];
        j  := Pos( '=', s );
        ti.Caption := copy( S, 1, j - 1 );
        ti.SubItems.Add( copy( S, j + 1, length( S ) - j ) );
      end;
      inc(k);
    end;

  end;
end;

function TSpriteForm.FindFieldSF( S : string ) : integer;
var
  k, j : integer;
  abc : string;
begin
  j := length( S ) + 1;
  for k := 0 to unit3.SpriteList.count - 1 do
  begin
    abc := copy( unit3.SpriteList[ k ], 0, j );
    if abc = S + '=' then
    begin
      result := k;
      exit;
    end;
  end;
  result := -1;
end;

function TSpriteForm.ReadSF( S : string ) : string;
var
  abc : string;
  k, j : integer;

begin
  j := FindFieldSF( S );
  if j < 0 then
  begin
    showmessage( 'Not a such field !' );
    exit;
  end;
  abc := unit3.SpriteList[ j ];
  k := Pos( '=', abc );
  abc := copy( abc, k + 1, length( abc ) - k );
  result := abc;

end;

procedure TSpriteForm.WriteSF( S, S2 : string );
var
  j : integer;

begin
  j := FindFieldSF( S );
  if j < 0 then
  begin
    showmessage( 'Not a such field !' );
    exit;
  end;
  unit3.SpriteList[ j ] := S + '=' + S2;
end;

procedure TSpriteForm.Open1Click( Sender : TObject );
var
  sn : string;
begin
  with Mainform.OpenDialog do
  begin
    DefaultExt := 'spr';
    Filter := 'Sprite files (*.spr)|*.spr';
    if Execute then
    begin
      unit3.SpriteList.free;
      unit3.SpriteList := TStringList.Create;
      sn := ExtractFilename( FileName );
      OpenSpriteFile( sn );
      Caption := sprTitle + ' - ' + sn;
    end;
  end;
end;

procedure TSpriteForm.Save1Click( Sender : TObject );
var
  sn : string;
begin
  Mainform.SaveDialog1.DefaultExt := 'spr';
  Mainform.SaveDialog1.Filter := 'Sprite files (*.spr)|*.spr';

  if Mainform.SaveDialog1.Execute then
  begin
    unit3.SpriteList.SaveToFile( Mainform.SaveDialog1.Filename );
    sn := ExtractFilename( Mainform.SaveDialog1.Filename );
    Caption := sprTitle + ' - ' + sn;
  end;
end;

procedure TSpriteForm.Exit1Click( Sender : TObject );
begin
  close;
end;

procedure TSpriteForm.Text1Click( Sender : TObject );
begin
  if SpriteList <> nil then
       FrmEditor.OpenEditor( edAnimation );
end;

procedure TSpriteForm.btnNewFrameClick( Sender : TObject );
begin
  Add1Click( self );
end;

procedure TSpriteForm.Add1Click( Sender : TObject );
begin
  if lvAnimations.Selected = nil then exit;
  SpriteDialog.InsertSprite( SpriteForm.lvAnimations.Selected.Caption, 'None' ); // sarebbe pnID.caption ma None aggiunge in coda all'anim
  SpriteDialog.LoadFrames;
  SpriteDialog.showmodal;
end;

procedure TSpriteForm.NoFrameSelected;
begin
  pnID.caption := 'None';
 //Image2.picture.free;
end;

procedure TSpriteForm.btnPlayAnimClick( Sender : TObject );
var
  CurrFrame : TFrameOld;
  k, cx, cy, start : integer;
  ft : Cardinal;
  clrscr : boolean;
begin
  if lvAnimations.Selected = nil then exit;

  if FLMode <> mdEnd then //ce n'e' gia' una
  begin
    FLMode := mdLoop;
    exit;
  end;

  if AnimFrameLst.Count = 0 then
  begin
    ShowMessage( 'Animation have not any frame!' );
    exit;
  end;

  speedbutton1.enabled := true;
  speedbutton2.enabled := true;
  btnPlayAnim.enabled := false;
  btnStopAnim.enabled := true;
  pnNF.caption := inttostr( AnimFrameLst.Count );

  imFrame.canvas.Brush.Style := bsSolid;
  imFrame.canvas.Brush.Color := clWhite;
  imFrame.canvas.rectangle( 0, 0, imFrame.width, imFrame.height ); //cls
  cx := imFrame.width div 2;
  cy := imFrame.height div 2;
  clrscr := clear1.checked;
  k := 0;
  FLMode := mdLoop;
  while FLmode <> mdEnd do /// animation loop
  begin
    CurrFrame := AnimFrameLst[ k ];
    pnID.caption := inttostr( CurrFrame.ID );

    ft := GetTickCount + CurrFrame.D * 10; // finish time (Durata in 1/100 di secondo)


    DessignAnimation( k );
{    with imFrame do
    begin
      if clrscr then canvas.rectangle( 0, 0, width, height );
      BitBlt( canvas.handle, cx - CurrFrame.BX, cy - CurrFrame.BY, CurrFrame.W, CurrFrame.H,
        SpriteDialog.ImageSprite.canvas.handle, CurrFrame.OX, CurrFrame.OY, SRCCOPY );
      Update;
    end; // with}

    while GetTickCount < ft do // aspetta il tempo giusto
      Application.ProcessMessages;

    while FLMode = mdStop do //aspetta per continuare
      Application.ProcessMessages;

    if FLMode = mdLoop then
    begin
      inc( k );
      if k = AnimFrameLst.Count then k := 0;
    end;
    if FLMode = mdForward then
    begin
      inc( k );
      if k = AnimFrameLst.Count then k := 0;
      FLMode := mdStop;
    end;
    if FLMode = mdBack then
    begin
      dec( k );
      if k = -1 then k := AnimFrameLst.Count - 1;
      FLMode := mdStop;
    end;
  end;

end;

procedure TSpriteForm.btnStopAnimClick( Sender : TObject );
begin
  FLMode := MdEnd;
  speedbutton1.enabled := false;
  speedbutton2.enabled := false;
  btnStopAnim.enabled := false;
  btnPlayAnim.enabled := true;
  pnID.caption := 'None';
  pnNF.caption := '0';
end;

procedure TSpriteForm.btnEditFrameClick( Sender : TObject );
begin
  Edit2Click( self );
end;

procedure TSpriteForm.Edit2Click( Sender : TObject );
begin
  if lvAnimations.Selected = nil then exit;
  SpriteDialog.LoadFrames;
  SpriteDialog.EditSprite( 0 );
  SpriteDialog.showmodal;
end;

procedure TSpriteForm.btnDeleteFrameClick( Sender : TObject );
begin
  Delete1Click( self );
end;

procedure TSpriteForm.Delete1Click( Sender : TObject );
var
  id : string;
  r : integer;
begin
  if lvAnimations.Selected = nil then exit;
  id := pnID.caption;
  if id = 'None' then
  begin
    ShowMessage( 'No frame selected!' );
    exit;
  end;
  r := Application.MessageBox( pchar( 'Are you sure deleting frame ' + id + ' ?' ), '', MB_ICONWARNING + MB_YESNO );
  if r = IDNO then exit;
  SpriteDialog.Delete( id );
end;

procedure TSpriteForm.SpeedButton2Click( Sender : TObject );
begin
  FLMode := mdBack;
  btnPlayAnim.enabled := true;
end;

procedure TSpriteForm.SpeedButton1Click( Sender : TObject );
begin
  FLMode := mdForward;
  btnPlayAnim.enabled := true;
end;


procedure TSpriteForm.Add2Click( Sender : TObject );
var
  s : string;
begin
  s := lvAnimations.Selected.Caption;
{  inputquery( 'New Animation', 'Insert name:', s );
  if lvAnimations.items.indexof( s ) < 0 then
  begin
    Nanimation.items.add( s );
    Nanimation.ItemIndex := Nanimation.Items.Count - 1;
    NAnimationClick( self );
    unit3.SpriteList.add( 'Animation=' + s ); //deve agggiungerla alla lista!
  end
  else
    showMessage( 'Animation ' + s + ' is present yet!' );}
end;

procedure TSpriteForm.btnAddAnimationClick( Sender : TObject );
begin
  Add2Click( self );
end;

{   This function search for the image file property and loads the image
    as a Bitmap
}
procedure TSpriteForm.SetAnimationImage( Anim : string );
var
  s : string;
  k, j : integer;
  imf : boolean;
begin
  with unit3.SpriteList do
  begin
    j := indexOf( 'Animation=' + Anim ) + 1; //inizio animazione
    if j < 0 then
    begin
      ShowMessage( 'Animation does not exist!' );
      exit;
    end;
    imf := false;
    for k := j to Count - 1 do
    begin
      s := Strings[ k ];
      if ( copy( s, 1, 9 ) = 'ImageFile' ) then
      begin
        imf := true;
        j := k; //segna dov'e segnato il filename
        break;
      end;
      if ( copy( s, 1, 9 ) = 'Animation' ) then //trovato l'anim successivo
        break;
    end;
    if not imf then // il primo
    begin
      showMessage( 'This is the first frame of ' + anim + ' animation. Please choose its Bmp file.' );
      with Mainform.OpenPictureDialog do
      begin
        DefaultExt := 'BMP';
        Filter := 'BMP files (*.bmp)|*.bmp';
        if Execute then
          s := ExtractFileName( Filename )
        else
          s := anim + '.bmp'; //alla peggio usa il nome dell'animazione stessa
      end;
      Insert( j, 'ImageFile=' + s ); // j punta al ancora alla riga dopo l'animazione
    end;
  end; //with unit3.spritelist
 /// ora carica il bmp!
  s := SpriteList[ j ];
  k := Pos( '=', s );
  s := copy( s, k + 1, length( s ) - k ); //prende il valore
  SpriteDialog.ImageSprite.picture.LoadFromFile( s );
  ImageBMP.picture.LoadFromFile( s );
end;

procedure TSpriteForm.NAnimationClick( Sender : TObject );
begin
  if btnStopAnim.enabled then btnStopAnimClick( self ); // ferma l'animazione
  NoFrameSelected;
  SetAnimationImage( lvAnimations.Selected.Caption );
end;

procedure TSpriteForm.Import1Click( Sender : TObject );
var
  s, nAnim, ndir : string;
  k, kx, ky, tH, mH, tW, mW, pins, tID : integer;
  TmpBmp, NewBmp : TBitMap;
  BmpFrame : TBmpFrame;
  pSL : PByteArray;
  srcRect : TRect;
begin
  nAnim := lvAnimations.Selected.Caption;
  if NAnim = '' then
  begin
    ShowMessage( 'No animation selected!' );
    exit;
  end;

  ndir := GetCurrentDir;
  ShowMessage( 'Select all files to import in animation <' + NAnim + '>. Cancel to abort' );
  with Mainform.OpenPictureDialog do
  begin
    DefaultExt := 'bmp';
    Filter := 'Bmp files (*.bmp)|*.bmp';
    Options := Options + [ ofAllowMultiSelect ];
    if Execute then
    begin
   {ShowMessage(inttostr(Files.Count));
   for k:=0 to Files.Count-1 do
    ShowMessage(Files[k]);}
      Screen.Cursor := crHourGlass;
   // inizializza oggetti necessari
      TmpBmp := TBitMap.Create;
      mW := 0;
      mH := 0;

      for k := 0 to Files.Count - 1 do
      begin
    //ShowMessage(Files[k]);
        BmpFrame := TBmpFrame.Create;
        TmpBmp.LoadFromFile( Files[ k ] );
        BmpFrame.Center.x := TmpBmp.Width div 2 + 1;
        BmpFrame.Center.y := TmpBmp.Height div 2 + 1;
        BmpFrame.Rect := Rect( 10000, 10000, 0, 0 );
        for ky := 0 to TmpBmp.Height - 1 do
        begin
          pSL := TmpBmp.ScanLine[ ky ];
          for kx := 0 to TmpBmp.Width - 1 do
            if pSL[ kx ] <> 255 then
            begin
              if kx < BmpFrame.Rect.Left then
                BmpFrame.Rect.Left := kx
              else if kx > BmpFrame.Rect.Right then
                BmpFrame.Rect.Right := kx;
              if ky < BmpFrame.Rect.Top then
                BmpFrame.Rect.Top := ky
              else if ky > BmpFrame.Rect.Bottom then
                BmpFrame.Rect.Bottom := ky;
            end;
        end;
        tW := BmpFrame.Rect.Right - BmpFrame.Rect.Left + 2; //sarebbe +1 ma 1 di bordo
        tH := BmpFrame.Rect.Bottom - BmpFrame.Rect.Top + 2; //sarebbe +1 ma 1 di bordo
    //ShowMessage('tH:'+inttostr(tH)+' tW:'+inttostr(tW));
        if tW > mW then mW := tW;
        mH := tH + mH;
    //ShowMessage('mH:'+inttostr(mH)+' mW:'+inttostr(mW));
        Files.Objects[ k ] := BmpFrame;
      end;
   // Crea nuova immagine
      NewBmp := TBitMap.Create;
      NewBmp.LoadFromFile( Files[ 0 ] ); //per evitare di defirlo compatibile
      NewBmp.Width := mW;
      NewBmp.Height := mH;
   //ShowMessage(inttostr(mH)+' '+inttostr(mW));
      NewBmp.Canvas.Brush.Color := clWhite;
      NewBmp.Canvas.FillRect( Rect( 0, 0, mW, mH ) );
      tH := 0;
      for k := 0 to Files.Count - 1 do
      begin
    //ShowMessage(Files[k]);
        TmpBmp.LoadFromFile( Files[ k ] );
        BmpFrame := TBmpFrame( Files.Objects[ k ] );
        srcRect := Rect( 0, tH, BmpFrame.Rect.Right - BmpFrame.Rect.Left + 1, BmpFrame.Rect.Bottom - BmpFrame.Rect.Top + tH + 1 );
        NewBmp.Canvas.CopyRect( srcRect, TmpBmp.Canvas, BmpFrame.Rect );
        tH := tH + BmpFrame.Rect.Bottom - BmpFrame.Rect.Top + 2; //sarebbe +1 ma 1 di bordo
        BmpFrame.Center.x := BmpFrame.Center.x - BmpFrame.Rect.Left;
        BmpFrame.Center.y := BmpFrame.Center.y - BmpFrame.Rect.Top;
        BmpFrame.Rect := srcRect;
      end;
   // Salva nuova immagine
      Mainform.SaveDialog1.DefaultExt := 'bmp';
      Mainform.SaveDialog1.Filter := 'Bmp files (*.bmp)|*.bmp';
      if Mainform.SaveDialog1.Execute then
      begin
        NewBmp.SaveToFile( Mainform.SaveDialog1.Filename );
        Screen.Cursor := crDefault;
        TmpBmp.Free;
        NewBmp.Free;
    // Cancella Frames animazione
        with unit3.SpriteList do
        begin
          pins := indexOf( 'Animation=' + nAnim ) + 1; //inizio animazione
          if pins < 0 then
          begin
            ShowMessage( 'Animation does not exist!' );
          end
          else
            for k := pins to Count - 1 do
            begin
              s := Strings[ k ];
              if ( copy( s, 1, 9 ) = 'Animation' ) then //trovato l'anim successivo
                break
              else
                Delete( k ); //cancella riga
            end;
     // Aggiunge nuovi Frames
          Insert( pins, 'ImageFile=' + ExtractFilename( Mainform.SaveDialog1.Filename ) ); //file image
          inc( pins );
          for k := 0 to Files.Count - 1 do
          begin
            BmpFrame := TBmpFrame( Files.Objects[ k ] );
            Insert( pins, 'ID=x' ); //inizia ad inserire i dati
            Insert( pins + 1, 'OX=' + inttostr( BmpFrame.Rect.Left ) );
            Insert( pins + 2, 'OY=' + inttostr( BmpFrame.Rect.Top ) );
            Insert( pins + 3, 'W=' + inttostr( BmpFrame.Rect.Right - BmpFrame.Rect.Left ) );
            Insert( pins + 4, 'H=' + inttostr( BmpFrame.Rect.Bottom - BmpFrame.Rect.Top ) );
            Insert( pins + 5, 'BX=' + inttostr( BmpFrame.Center.x ) );
            Insert( pins + 6, 'BY=' + inttostr( BmpFrame.Center.y ) );
            Insert( pins + 7, 'D=10' );
            Insert( pins + 8, 'FX=0' );
            Insert( pins + 9, ';' );
            pins := pins + 10;
          end;

     // Sistema tutti ID e NF
          tID := 0;
          for k := 0 to Count - 1 do
          begin
            s := Strings[ k ];
            if copy( s, 1, 3 ) = 'ID=' then //trovato un ID
            begin
              Strings[ k ] := 'ID=' + inttostr( tID );
              inc( tID );
            end;
          end;
          SpriteForm.writeSF( 'NF', inttostr( tID ) ); // aggiorna NF
     //aggiorna immagine
//          Nanimation.OnClick( self );
        end;
      end;
      for k := 0 to Files.Count - 1 do
        TBmpFrame( Files.Objects[ k ] ).Free;
    end;
    Options := Options - [ ofAllowMultiSelect ];
  end;
end;

//******************************************************************************
// New functions by John Lohmeyer 17/08/2000

function TSpriteForm.CountFrameAnim( NameAnim : string ) : integer;
var
  nFrames, k : integer;
begin
  nFrames := -1;  // This is not an animation
  k := SpriteList.indexOf( 'Animation=' + NameAnim ) + 1; // Search the animation, slow but works
  if k > 0 then
  begin
    nFrames := 0;
    // The while bucles performs a faster running than the for next
    while k < SpriteList.Count - 1 do
    begin
      if ( copy( SpriteList.Strings[ k ], 1, 2 ) = 'ID' ) then // trovato un nuovo ID da inserire
           Inc( nFrames );  // Count the frame
      if ( copy( SpriteList.Strings[ k ], 1, 9 ) = 'Animation' ) then //l'anim successivo
           break;
      inc(k);
    end;
  end; // if
  Result := nFrames;
end;

{   When we select an animation, load all the bitmap and show the animation
}
procedure TSpriteForm.lvAnimationsSelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
begin
  if lvAnimations.Selected <> nil then
  begin
    if btnStopAnim.enabled then btnStopAnimClick( self ); // ferma l'animazione
    NoFrameSelected;
    SetAnimationImage( lvAnimations.Selected.Caption );
    SetAnimation( lvAnimations.Selected.Caption );
    DessignAnimation( 0 );
  end;
end;

{  Read all info of animation on memory, this improve fast speed!
   and it has to read only one!
}
procedure TSpriteform.SetAnimation( AnimName : string );
var
  k, cx, cy, start : integer;
  ft : Cardinal;
  clrscr : boolean;
  CurrFrame : TFrameOld;
  WidthImage, HeightImage : Integer;
begin
  // Delete all
  for k := 0 to AnimFrameLst.count - 1 do
  begin
    CurrFrame := AnimFrameLst[ k ];
    CurrFrame.free;
  end;
  AnimFrameLst.Clear;
  WidthImage := 0; HeightImage := 0;
  k := SpriteList.indexOf( 'Animation=' + AnimName ) + 1; //inizio animazione
//  if start > 0 then
//  begin
    while k < SpriteList.Count - 1 do
    begin
      if ( copy( SpriteList.Strings[ k ], 1, 2 ) = 'ID' ) then // trovato un nuovo ID da inserire
      begin
        CurrFrame := TFrameOld.Create;
        with CurrFrame do
        begin
          ID := strtoint( copy( SpriteList.Strings[ k + 0 ], 4, 100 ) );
          OX := strtoint( copy( SpriteList.Strings[ k + 1 ], 4, 100 ) );
          OY := strtoint( copy( SpriteList.Strings[ k + 2 ], 4, 100 ) );
          W  := strtoint( copy( SpriteList.Strings[ k + 3 ], 3, 100 ) );
          H  := strtoint( copy( SpriteList.Strings[ k + 4 ], 3, 100 ) );
          BX := strtoint( copy( SpriteList.Strings[ k + 5 ], 4, 100 ) );
          BY := strtoint( copy( SpriteList.Strings[ k + 6 ], 4, 100 ) );
          D  := strtoint( copy( SpriteList.Strings[ k + 7 ], 3, 100 ) );
          if W > WidthImage  then WidthImage := W;
          if H > HeightImage then HeightImage:= H;
        end;
        AnimFrameLst.Add( CurrFrame ); //lo aggiunge alla lista
      end;
      if ( copy( SpriteList.Strings[ k ], 1, 9 ) = 'Animation' ) then //l'anim successivo
           break;
      inc(k);
    end; // while k ...
    // Get the paint position and the base for the sprite
    LeftImage := (imFrame.width  - WidthImage)  div 2;
    TopImage  := (imFrame.height - HeightImage) div 2;
//  end; // if
end;

{   This will reder all animation
}
procedure TSpriteform.DessignAnimation( Frame : integer );
var
  CurrFrame : TFrameOld;
  k, cx, cy, start : integer;
  ft : Cardinal;
  strech : boolean;
begin
  ImageFrame1.canvas.FillRect( Rect(0, 0, ImageFrame1.width, ImageFrame1.height) ); // clear it
  ImageFrame2.canvas.FillRect( Rect(0, 0, ImageFrame2.width, ImageFrame2.height) ); // clear it
  ImageFrame3.canvas.FillRect( Rect(0, 0, ImageFrame3.width, ImageFrame3.height) ); // clear it}

  if AnimFrameLst.Count = 0 then exit;                   // Not defined
  if Frame > AnimFrameLst.Count then Frame := 0;         // If we pass a wrong arg, then to 0

  CurrFrame := AnimFrameLst[ Frame ];
  pnID.caption := inttostr( CurrFrame.ID );

  { Use a tiled background, get the original one! }
{  if chUseMapTile.checked then
  begin}
  cx := imFrame.width div 2;
  cy := imFrame.height div 2;
  imFrame.canvas.Brush.style := bsClear;
  SpriteDialog.ImageSprite.Canvas.Brush.Color := clWhite;
  SpriteDialog.ImageSprite.Canvas.CopyMode    := cmMergeCopy;
       {BitBlt( imFrame.canvas.handle, 0, 0, imFrame.Width, imFrame.Height,
                  Mainform.Image.canvas.handle, 0, 0, SRCCOPY );}
  imFrame.canvas.BrushCopy( Rect( cx - CurrFrame.BX, cy - CurrFrame.BY, (cx-CurrFrame.BX) + CurrFrame.W, (cy - CurrFrame.BY)+CurrFrame.H),
                                  SpriteDialog.ImageSprite.Picture.Bitmap, Rect( CurrFrame.OX, CurrFrame.OY,
                                  (CurrFrame.OX + CurrFrame.W),  (CurrFrame.OY + CurrFrame.H)), clWhite );
{  end
  else
  begin
  cx := imFrame.width div 2;
  cy := imFrame.height div 2;
  imFrame.canvas.FillRect( Rect(0, 0, imFrame.width, imFrame.height) ); //cls
  BitBlt( imFrame.canvas.handle, cx - CurrFrame.BX, cy - CurrFrame.BY, CurrFrame.W, CurrFrame.H,
                  SpriteDialog.ImageSprite.canvas.handle, CurrFrame.OX, CurrFrame.OY, SRCCOPY );
}
  // Frames!!
  cx := ImageFrame1.width div 2;
  cy := ImageFrame1.height div 2;
  if (CurrFrame.W > ImageFrame1.width) or (CurrFrame.H > ImageFrame1.height) then
       strech := True else strech := False;

  // Actual Frame
  if strech then
      StretchBlt( ImageFrame2.canvas.handle, 0, 0, ImageFrame1.Width, ImageFrame1.Height,
            SpriteDialog.ImageSprite.canvas.handle, CurrFrame.OX, CurrFrame.OY, CurrFrame.W, CurrFrame.H, SRCCOPY )
    else
      BitBlt( ImageFrame2.canvas.handle, cx - CurrFrame.BX, cy - CurrFrame.BY, CurrFrame.W, CurrFrame.H,
            SpriteDialog.ImageSprite.canvas.handle, CurrFrame.OX, CurrFrame.OY, SRCCOPY );

  // Next Frame
  if Frame + 1 < AnimFrameLst.Count then
  begin
    CurrFrame := AnimFrameLst[ Frame + 1 ];
    if strech then
        StretchBlt( ImageFrame3.canvas.handle, 0, 0, ImageFrame1.Width, ImageFrame1.Height,
            SpriteDialog.ImageSprite.canvas.handle, CurrFrame.OX, CurrFrame.OY, CurrFrame.W, CurrFrame.H, SRCCOPY )
    else
        BitBlt( ImageFrame3.canvas.handle, cx - CurrFrame.BX, cy - CurrFrame.BY, CurrFrame.W, CurrFrame.H,
            SpriteDialog.ImageSprite.canvas.handle, CurrFrame.OX, CurrFrame.OY, SRCCOPY );
  end;

  // Previus Frame
  if Frame - 1 >= 0 then
  begin
    CurrFrame := AnimFrameLst[ Frame - 1 ];
    if strech then
        StretchBlt( ImageFrame1.canvas.handle, 0, 0, ImageFrame1.Width, ImageFrame1.Height,
            SpriteDialog.ImageSprite.canvas.handle, CurrFrame.OX, CurrFrame.OY, CurrFrame.W, CurrFrame.H, SRCCOPY )
    else
        BitBlt( ImageFrame1.canvas.handle, cx - CurrFrame.BX, cy - CurrFrame.BY, CurrFrame.W, CurrFrame.H,
            SpriteDialog.ImageSprite.canvas.handle, CurrFrame.OX, CurrFrame.OY, SRCCOPY );
  end;

  // Update it
  imFrame.Repaint;
  ImageFrame1.Repaint;
  ImageFrame2.Repaint;
  ImageFrame3.Repaint;
end;

end.
