unit UTextEditor;

// Code tidied by Dominique Louis November 1999

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, unit3, Buttons;

type
  TFrmEditor = class( TForm )
    Panel1 : TPanel;
    btnCancel: TButton;
    btnOK: TButton;
    Memo: TMemo;
    Panel2: TPanel;
    btnCopy: TSpeedButton;
    btnCut: TSpeedButton;
    btnPaste: TSpeedButton;
    Bevel1: TBevel;
    btnUndo: TSpeedButton;
    btnFind: TSpeedButton;
    Bevel2: TBevel;
    procedure btnOKClick( Sender : TObject );
    procedure btnDoActionsClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    typeEditor : integer; // Use the same editor, for different purposes
    procedure OpenEditor( typeEdit : integer );
  end;

const
  edAnimation = 0;
  edTiles = 1;

var
  FrmEditor : TFrmEditor;

implementation

uses UTilesForm;

{$R *.DFM}

procedure TFrmEditor.OpenEditor( typeEdit : integer );
begin
  typeEditor := typeEdit;
  memo.lines.clear;     // Clear it
  // Assign some stuff on it
  case typeEditor of
    edAnimation:
       begin
         memo.lines.addstrings( unit3.SpriteList );
       end;
    edTiles:
       begin
         memo.lines := unit3.TileList;
       end;
  end;
  ShowModal;
end;

procedure TFrmEditor.btnOKClick( Sender : TObject );
begin
  // Before closing the editor, do some action
  case typeEditor of
    edAnimation:
       begin
         unit3.SpriteList.clear;
         unit3.SpriteList.addstrings( memo.lines );
       end;
    edTiles:
       begin
         unit3.TileList.clear;
         unit3.TileList.addstrings( memo.lines );
         TilesForm.shape1.visible := false;
         TilesForm.imageTiles.picture.LoadFromFile( unit3.TileList[ 0 ] );
         TilesForm.LoadList;
       end; // case edTiles
  end; // case
  close;
end;


procedure TFrmEditor.btnDoActionsClick(Sender: TObject);
var
  txt : string;
begin
  if Sender = btnCopy then
       Memo.CopyToClipboard;
  if Sender = btnCut then
       Memo.CutToClipboard;
  if Sender = btnPaste then
       Memo.PasteFromClipboard;
  if Sender = btnUndo then
       Memo.Undo;
  if Sender = btnFind then
  begin
    txt := InputBox('Input Box', 'What to search for?', '');
    // Implement the search action
  end;
end;

end.
