unit UTilesForm;

// Code tidied by Dominique Louis November 1999

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, ExtCtrls, ComCtrls, Buttons;

type
  TTilesForm = class( TForm )
    ScrollBox1 : TScrollBox;
    MainMenu1 : TMainMenu;
    Import1 : TMenuItem;
    LoadBMP1 : TMenuItem;
    Tiles1 : TMenuItem;
    mnuNewTile: TMenuItem;
    mnuEditTile: TMenuItem;
    File1 : TMenuItem;
    New2 : TMenuItem;
    Open1 : TMenuItem;
    Save1 : TMenuItem;
    Edit2 : TMenuItem;
    Shape2: TShape;
    N1 : TMenuItem;
    Exit1 : TMenuItem;
    Text1 : TMenuItem;
    N2 : TMenuItem;
    N111 : TMenuItem;
    N211 : TMenuItem;
    N411 : TMenuItem;
    Hline : TShape;
    Vline : TShape;
    N3 : TMenuItem;
    crosslines1 : TMenuItem;
    StatusBar1 : TStatusBar;
    Shape1: TShape;
    ImageTiles: TImage;
    Panel1: TPanel;
    lvTiles: TListView;
    Label1: TLabel;
    Label2: TLabel;
    PanelPreview: TPanel;
    ImagePreview1: TImage;
    btnAddTile: TSpeedButton;
    btnProperties: TSpeedButton;
    btnBlack: TSpeedButton;
    procedure LoadBMP1Click( Sender : TObject );
    procedure New2Click( Sender : TObject );
    procedure mnuNewTileClick( Sender : TObject );
    procedure Save1Click( Sender : TObject );
    procedure mnuEditTileClick( Sender : TObject );
    procedure FormCreate( Sender : TObject );
    procedure Open1Click( Sender : TObject );
    procedure ScrollBox1Click( Sender : TObject );
    procedure Exit1Click( Sender : TObject );
    procedure FormCloseQuery( Sender : TObject; var CanClose : Boolean );
    procedure N411Click( Sender : TObject );
    procedure N111Click( Sender : TObject );
    procedure N211Click( Sender : TObject );
    procedure ImageTilesMouseMove( Sender : TObject; Shift : TShiftState; X,
      Y : Integer );
    procedure crosslines1Click( Sender : TObject );
    procedure ImageTilesDblClick( Sender : TObject );
    procedure Text1Click( Sender : TObject );
    procedure ScrollBox1MouseMove( Sender : TObject; Shift : TShiftState; X,
      Y : Integer );
    procedure ImageTilesMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ImageTilesMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure lvTilesSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure lvTilesDblClick(Sender: TObject);
    procedure btnBlackClick(Sender: TObject);
  private
    { Private declarations }
    FixedX, FixedY : integer;   // When we press the left button maintens the coord
  public
    { Public declarations }
    zoomimage : integer;
    procedure OpenTilesFile( FileName : string );
    procedure LoadList;      // From memory, load all
  end;

var
  TilesForm : TTilesForm;

implementation

uses UMain, Unit3, UNewTiles, UtileData, UTextEditor;

{$R *.DFM}

procedure TTilesForm.FormCreate( Sender : TObject );
begin
//separator.top:=0;
//separator.width:=2;
  shape1.visible := false;
  Hline.visible := true;
  Vline.visible := true;
  zoomimage := 1;
end;

procedure TTilesForm.LoadBMP1Click( Sender : TObject );
begin
  if unit3.TileList = nil then exit;
  with Mainform.OpenPictureDialog do
  begin
    DefaultExt := 'BMP';
    Filter := 'BMP files (*.bmp)|*.bmp';
    if Execute then
    begin
      shape1.visible := false;
      unit3.TileList[ 0 ] := ExtractFileName( Filename );
      ImageTiles.picture.LoadFromFile( unit3.TileList[ 0 ] );
      if ImageTiles.picture.Bitmap = nil then
          ShowMessage('Wrong file format');
      N111Click( Sender );
    end;
  end;

end;

procedure TTilesForm.New2Click( Sender : TObject );
begin
  if NewTiles.showmodal = mrOK then
      lvTiles.Items.Clear;
end;

procedure TTilesForm.mnuNewTileClick( Sender : TObject );
begin
  if unit3.TileList = nil then exit;
  TileDialog.AddTile;
  TileDialog.showmodal;
end;

procedure TTilesForm.Save1Click( Sender : TObject );
begin
  if unit3.TileList = nil then exit;

  Mainform.SaveDialog1.DefaultExt := 'tls';
  Mainform.SaveDialog1.Filter := 'Tile List files (*.tls)|*.tls';

  if Mainform.SaveDialog1.Execute then
       unit3.TileList.SaveToFile( Mainform.SaveDialog1.Filename );

end;

{   Edit the properties of the tile
}
procedure TTilesForm.mnuEditTileClick( Sender : TObject );
begin
  if ImageTiles.Picture.Graphic = nil then exit;
  if lvTiles.Selected = nil then exit;
  TileDialog.EditTile( lvTiles.Selected.Caption );
  TileDialog.showmodal;
end;

procedure TTilesForm.Open1Click( Sender : TObject );

begin
  with Mainform.OpenDialog do
  begin
    DefaultExt := 'tls';
    Filter := 'Tile List files (*.tls)|*.tls';
    if Execute then
    begin
      unit3.TileList.free;
      unit3.TileList := TStringList.Create;
      OpenTilesFile( ExtractFileName( Filename ) );
      N111Click( Sender );
    end;
  end;
end;

procedure TTilesForm.ScrollBox1Click( Sender : TObject );
begin
  shape1.visible := false;
end;

procedure TTilesForm.OpenTilesFile( FileName : string );
begin
  if FileName <> '' then
  begin
    unit3.TileList.LoadFromFile( Filename );
    imageTiles.picture.LoadFromFile( unit3.TileList[ 0 ] );
    LoadList;
  end;
end;

{   Reload all values from the memory to the list view
}
procedure TTilesForm.LoadList;
var
  nt, k, j, currentline : integer;
  S : string;
  ti: TListItem;
begin
    nt := strtoint( unit3.TileList[ 1 ] );
    lvTiles.Items.Clear;          // Clear all items
    if nt > 0 then
    begin
      for k := 0 to nt - 1 do
      begin
        ti := lvTiles.Items.Add;
        currentline := unit3.TileList.indexof( 'ID=' + inttostr( k ) );
        S := unit3.TileList[ currentline + 1 ];
        j := Pos( '=', S );
        ti.Caption := inttostr( k );
        ti.SubItems.Add( copy( S, j + 1, length( S ) - j ) );
        //.. X
        S := unit3.TileList[ currentline + 2 ];
        j := Pos( '=', S );
        ti.SubItems.Add( copy( S, j + 1, length( S ) - j ) ); // X
        // .. Y
        S := unit3.TileList[ currentline + 3 ];
        j := Pos( '=', S );
        ti.SubItems.Add( copy( S, j + 1, length( S ) - j ) ); // Y
        // .. W
        S := unit3.TileList[ currentline + 4 ];
        j := Pos( '=', S );
        ti.SubItems.Add( copy( S, j + 1, length( S ) - j ) ); // W
        // .. H
        S := unit3.TileList[ currentline + 5 ];
        j := Pos( '=', S );
        ti.SubItems.Add( copy( S, j + 1, length( S ) - j ) ); // H
      end;
    end;
end;

procedure TTilesForm.Exit1Click( Sender : TObject );
begin
  close;
end;

procedure TTilesForm.FormCloseQuery( Sender : TObject;
  var CanClose : Boolean );
begin
  mainform.tiles1.checked := false;
end;

procedure TTilesForm.N411Click( Sender : TObject );
begin
  zoomimage := 4;
  ScrollBox1.VertScrollBar.position := 0;
  ScrollBox1.HorzScrollBar.position := 0;
  ImageTiles.width := ImageTiles.picture.width * 4;
  ImageTiles.height := ImageTiles.picture.height * 4;
  N411.checked := true;
  lvTilesSelectItem(Sender, nil, False);
end;

procedure TTilesForm.N111Click( Sender : TObject );
begin
  zoomimage := 1;
  ScrollBox1.VertScrollBar.position := 0;
  ScrollBox1.HorzScrollBar.position := 0;
  ImageTiles.width := ImageTiles.picture.width;
  ImageTiles.height := ImageTiles.picture.height;
  N111.checked := true;
  lvTilesSelectItem(Sender, nil, False);
end;

procedure TTilesForm.N211Click( Sender : TObject );
begin
  zoomimage := 2;
  ScrollBox1.VertScrollBar.position := 0;
  ScrollBox1.HorzScrollBar.position := 0;
  ImageTiles.width := (ImageTiles.picture.width * 2);
  ImageTiles.height := (ImageTiles.picture.height * 2);
  ImageTiles.Refresh;
  N211.checked := true;
  lvTilesSelectItem(Sender, nil, False);
end;


procedure TTilesForm.crosslines1Click( Sender : TObject );
begin
  crosslines1.checked := not crosslines1.checked;
  Hline.visible := crosslines1.checked;
  Vline.visible := crosslines1.checked;
end;

procedure TTilesForm.ImageTilesDblClick( Sender : TObject );
begin
  if ImageTiles.Picture.Graphic = nil then exit;
  TileDialog.AddTile;
  TileDialog.edit2.text := StatusBar1.Panels.Items[ 2 ].Text;
  TileDialog.edit3.text := StatusBar1.Panels.Items[ 4 ].Text;
  TileDialog.showmodal;
end;

procedure TTilesForm.Text1Click( Sender : TObject );
begin
  if ImageTiles.Picture.Graphic <> nil then
       FrmEditor.OpenEditor( edTiles );
end;

procedure TTilesForm.ScrollBox1MouseMove( Sender : TObject;
  Shift : TShiftState; X, Y : Integer );
begin
  if ImageTiles.Picture.Graphic = nil then exit;
  Hline.visible := false;
  Vline.visible := false;
end;

procedure TTilesForm.ImageTilesMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  sbh, sbv : integer;
begin
  if ImageTiles.Picture.Graphic = nil then exit;
  if Button = mbLeft then
  begin
    sbh := {ScrollBox1.HorzScrollBar.position} -ImageTiles.Left;
    sbv := {ScrollBox1.VertScrollBar.position} -ImageTiles.Top;
    shape2.SetBounds( ( ( X - sbh ) div zoomimage ) * zoomimage, ( ( Y - sbv ) div zoomimage ) * zoomimage, 0, 0 );
    shape2.visible := True;
    Shape1.visible := False;
    FixedX := X; FixedY := Y;
  end;
end;

procedure TTilesForm.ImageTilesMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  sbh, sbv : integer;
begin
  if ImageTiles.Picture.Graphic = nil then exit;
  sbh := {ScrollBox1.HorzScrollBar.position} -ImageTiles.Left;
  sbv := {ScrollBox1.VertScrollBar.position} -ImageTiles.Top;
  if not shape2.visible then
  begin
    shape2.SetBounds( 0, 0, ( ( X - sbh ) div zoomimage ) * zoomimage, ( ( Y - sbv ) div zoomimage ) * zoomimage );
  end
  else
  begin
    shape2.width := ( ( X - shape2.left - sbh ) div zoomimage ) * zoomimage;
    shape2.height := ( ( Y - shape2.top - sbv ) div zoomimage ) * zoomimage;
  end;
  shape2.visible := false;
  if ((shape2.width div zoomimage) >= 1) and ((shape2.height div zoomimage) >= 1) then
  begin
    TileDialog.AddTile;
    TileDialog.upDown1.Position := FixedX div zoomimage;
    TileDialog.upDown2.Position := FixedY div zoomimage;
    TileDialog.upDown3.Position := shape2.width div zoomimage;
    TileDialog.upDown4.Position := shape2.height div zoomimage;
    TileDialog.Showmodal;
  end;
end;

procedure TTilesForm.ImageTilesMouseMove( Sender : TObject;
  Shift : TShiftState; X, Y : Integer );
var
  sbv, sbh : integer;
begin

  sbv := {ScrollBox1.VertScrollBar.position} -ImageTiles.Top;
  sbh := {ScrollBox1.HorzScrollBar.position} -ImageTiles.Left;
  if crosslines1.checked then
  begin
    Vline.SetBounds( ( ( X - sbh ) div zoomimage ) * zoomimage, ( ( Y - sbv + 10 ) div zoomimage ) * zoomimage, 1, ImageTiles.height - Y + sbv - 10 );
    if not Vline.visible then Vline.visible := true;
    Hline.SetBounds( ( ( X - sbh + 10 ) div zoomimage ) * zoomimage, ( ( Y - sbv ) div zoomimage ) * zoomimage, ImageTiles.width - X + sbh - 10, 1 );
    if not Hline.visible then Hline.visible := true;
  end;
  if shape2.visible then
  begin
    shape2.width := ( ( X - shape2.left - sbh ) div zoomimage ) * zoomimage;
    shape2.height := ( ( Y - shape2.top - sbv ) div zoomimage ) * zoomimage;
    StatusBar1.Panels.Items[ 0 ].Text := '('+inttostr(shape2.left) + ',' + inttostr(shape2.Top) + ') - (' +
                             inttostr(shape2.Width) + ',' + inttostr(shape2.Height) + ')';
  end;
  StatusBar1.Panels.Items[ 2 ].Text := inttostr( X div zoomimage );
  StatusBar1.Panels.Items[ 4 ].Text := inttostr( Y div zoomimage );
{
sbv:=ScrollBox1.VertScrollBar.position;
sbh:=ScrollBox1.HorzScrollBar.position;
if crosslines1.checked then
 begin
 Vline.SetBounds(X-sbh,Y-sbv+10,1,ImageTiles.height-Y+sbv-10);
 if not Vline.visible then Vline.visible:=true;
 Hline.SetBounds(X-sbh+10,Y-sbv,ImageTiles.width-X+sbh-10,1);
 if not Hline.visible then Hline.visible:=true;
 end;
StatusBar1.Panels.Items[1].Text :=inttostr(X div zoomimage);
StatusBar1.Panels.Items[3].Text :=inttostr(Y div zoomimage);
}
end;

{   Select the item
}
procedure TTilesForm.lvTilesSelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
var
  px, py, sx, sy, sw, sh, current, currentline, k : integer;
  S : string;
begin
  if lvTiles.Selected = nil then exit;
  TileDialog.edit9.text := inttostr( current );
  currentline := unit3.TileList.indexof( 'ID=' + lvTiles.Selected.Caption );
  if currentline < 0 then exit;
  with TileDialog do
  begin
    S := unit3.TileList[ currentline + 2 ];
    k := Pos( '=', S );
    S := copy( S, k + 1, length( S ) - k );
    sx := strtoint( S );         // SX
    S := unit3.TileList[ currentline + 3 ];
    k := Pos( '=', S );
    sy := strtoint( copy( S, k + 1, length( S ) - k ) );           // SY
    S := unit3.TileList[ currentline + 4 ];
    k := Pos( '=', S );
    sw := strtoint( copy( S, k + 1, length( S ) - k ) );           //SW
    S := unit3.TileList[ currentline + 5 ];
    k := Pos( '=', S );
    sh := strtoint( copy( S, k + 1, length( S ) - k ) );           // SH
    shape1.top := imageTiles.top + sy * zoomimage;
    shape1.left := imageTiles.left + sx * zoomimage;
    shape1.width := sw * zoomimage;
    shape1.height := sh * zoomimage;
//    if zoomimage > 1 then
//    begin
      ScrollBox1.VertScrollBar.position := sy * zoomimage - 10;
      ScrollBox1.HorzScrollBar.position := sx * zoomimage - 10;
//    end;
    shape1.visible := true;

    // Preview it
    px :=  (ImagePreview1.width - sw) div 2;
    py :=  (ImagePreview1.Height - sh) div 2;
    ImagePreview1.canvas.FillRect( Rect( 0, 0, ImagePreview1.width, ImagePreview1.height ) );
    BitBlt( ImagePreview1.canvas.handle, px, py, sw, sh, ImageTiles.canvas.handle, sx, sy, SRCCopy );
    ImagePreview1.Repaint;
  end; //with
end;

procedure TTilesForm.lvTilesDblClick(Sender: TObject);
begin
  mnuEditTileClick( self );
end;

procedure TTilesForm.btnBlackClick(Sender: TObject);
begin
  if lvTiles.Selected = nil then exit;

end;

end.
