unit Unit3;

// Code tidied by Dominique Louis November 1999

// ReCoded tidied by John Lohmeyer 2000-2001
// 	Implemented sprites and diretx

interface

uses
  Controls, Messages, Windows, Classes, Graphics, Dialogs, SysUtils, Forms,
  DXDraws, DirectX;

const
  maxalt = 7;
  MAX_FRAMES = 1000; // Nel definitivo andr rimossa
  MAX_ANIMATIONS = 100; // Nel definitivo andr rimossa

type
  TRawData = array[ 0..1 ] of byte;

  TFrameOld = class( TObject )
      ID,
      OX, OY,
      W, H,
      BX, BY : integer;
      D : Cardinal;
  end;

  TMap = class( TObject )
    MapName : string;
    Width   : word;
    Height  : word;
    RawData : ^TRawData;
    constructor Create;
    destructor  Destroy; override;
    procedure   DoPlane;
    procedure   LoadFromFile( FileName : string );
    procedure   SaveToFile( FileName : string );
    procedure   SetAltitude( X, Y, al : integer );
    procedure   SetTile( X, Y, ti : integer );
    function    GetAltitude( X, Y : integer ) : byte;
    function    GetTile( X, Y : integer ) : byte;
    procedure   CustomFill( x1, y1, x2, y2, al : integer );

    //property Altitude(X,Y:word): byte  read GetAltidude write SetAltidude;
    //property Tile(X,Y:word): byte  read GetTile write SetTile;

  end;

  TTile = class( TObject )
    ID       : word;
    Name     : string;
    OriginX  : word;
    OriginY  : word;
    Width    : integer;
    Height   : integer;
    ShiftY   : integer;
    TileType : byte;
    IDPlane  : word;
  end;

  TTerrain = class( TObject )
    Filename   : string;     // New!! filename
    NameImage  : string;
    Number     : word;
    StndWidth  : integer;
    StndHeight : integer;
    LevelShift : integer;
    Bmp        : TBitmap;
    Surface    : TDirectDrawSurface;
    Tiles      : Tlist;
    constructor Create;
    destructor  Destroy; override;
    procedure   LoadFromFile( sFileName : string );
  end;

  {   Some stuff for the sprites
  }

  TFrame = record
    FRect : TRect; // coordinate del punto sx,alto,dx,basso del frame
    BaseOffset : TPoint;
    Surface : TDirectDrawSurface;
    Bitmap : TBitmap;
    Duration : Integer; // durata in Tick cioe' Flip dello schermo
    Effects : Integer;
  end;

 TSprite = class;

 TSpriteData = class
  private
    FDirectDraw : TDirectDraw;
    //FBltFX : TDDBLTFX;
  public
    FileName : string;
    Name : string;
    FFrames : array[ 0..MAX_FRAMES ] of TFrame;
    //function GetAnimationLength( Animation : Integer ) : Integer;
    //function Draw( ASprite : TSprite ) : TRect;
    //procedure Restore;
    constructor Create( SpriteFile : string ); //; DirectDraw : TDirectDraw; Color : Integer; Delay : integer ); //Ub messo qui il file
    procedure Draw(Frame, X, Y : integer );
  end;

 TSprite = class
  private
  public
    Name : string;
    FSpriteData : TSpriteData;
    X, Y, BaseX, BaseY   : Integer;
    constructor Create( SpriteData : TSpriteData ); overload;
    constructor Create( SpriteFile : string ); overload;
    procedure Draw;  // Draws in directX
 end;

 TSprites = class( TObject )
  private
  public
    FSpriteDataList : Tlist;
    FSpriteList : TList;
    SpritesName : string;
    constructor Create;
    destructor  Destroy; override;
    procedure   LoadFromFile( FileName : string );
    procedure   SaveToFile( FileName : string );
    function    LoadSpriteData( SpriteFile : string ) : TSpriteData;
 end;

var
  TileList, SpriteList : TStringList;
  Map : TMap;
  Terrain : TTerrain;
  SpritesPos  : TSprites;
  DX_Draw    : TDXDraw;


implementation

//uses UMain, UCustomFill;

constructor TMap.Create;
begin
  inherited Create;
  MapName := 'NewMap';
  width := 10;
  height := 10;
  if RawData <> nil then FreeMem( RawData );
  GetMem( RawData, Width * Height * 2 );
end;

destructor TMap.Destroy;
begin
  FreeMem( RawData );
  inherited Destroy;
end;


procedure TMap.SetAltitude( X, Y, al : integer );
var
  mem : integer;

begin
  if ( ( x < width ) and ( x >= 0 ) ) and ( ( y < height ) and ( y >= 0 ) ) then
    if RawData <> nil then
    begin
      mem := 2 * ( X + Y * width );
      RawData[ mem ] := al mod 256;
    end;

end;

procedure TMap.SetTile( X, Y, ti : integer );
var
  mem : integer;

begin
  if ( ( x < width ) and ( x >= 0 ) ) and ( ( y < height ) and ( y >= 0 ) ) then
    if RawData <> nil then
    begin
      mem := 2 * ( X + Y * width );
      RawData[ mem + 1 ] := ti mod 256;
    end;
end;

function TMap.GetAltitude( X, Y : integer ) : byte;
var
  mem : integer;

begin
  result := 0;
  if ( ( x < width ) and ( x >= 0 ) ) and ( ( y < height ) and ( y >= 0 ) ) then
    if RawData <> nil then
    begin
      mem := 2 * ( X + Y * width );
      result := RawData[ mem ];
    end
end;

function TMap.GetTile( X, Y : integer ) : byte;
var
  mem : integer;

begin
  result := 0;
  if ( ( x < width ) and ( x >= 0 ) ) and ( ( y < height ) and ( y >= 0 ) ) then
    if RawData <> nil then
    begin
      mem := 2 * ( X + Y * width );
      result := RawData[ mem + 1 ];
    end
end;

procedure TMap.LoadFromFile( FileName : string );
var
  FStream : TfileStream;
  xx, yy : integer;
  alt, til : byte;
  rawTile : word;

begin
  if Fileexists( FileName ) then
  begin
 {if map<>nil then map.free;
 map:=Tmap.create;}
    MapName := FileName;
    FStream := TfileStream.create( FileName, fmOpenRead );
    if RawData <> nil then FreeMem( RawData, Width * Height * 2 );
    FStream.ReadBuffer( Width, 2 );
    FStream.ReadBuffer( Height, 2 );

    GetMem( RawData, Width * Height * 2 );
 //FStream.ReadBuffer(RawData^,sizeof(RawData));
    screen.cursor := crHourGlass;
    try
      for xx := 0 to width - 1 do
        for yy := 0 to height - 1 do
        begin
          FStream.ReadBuffer( rawTile, 2 );
          alt := RawTile mod 256;
          til := RawTile div 256;
          SetAltitude( xx, yy, alt );
          SetTile( xx, yy, til );
        end;
    finally
      Screen.Cursor := crDefault; { Always restore to normal }
      FStream.free;
    end;
  end
  else
    showmessage( 'File not exist' );
end;

procedure TMap.SaveToFile( FileName : string );
var
  FStream : TfileStream;
  xx, yy : integer;
  alt, til : byte;
begin
  MapName := FileName;
  if RawData <> nil then
  begin
    FStream := TfileStream.create( FileName, fmCreate );
    FStream.WriteBuffer( Width, 2 );
    FStream.WriteBuffer( Height, 2 );
 //FStream.WriteBuffer(RawData^,sizeof(RawData));

    for xx := 0 to width - 1 do
      for yy := 0 to height - 1 do
      begin
        alt := getAltitude( xx, yy );
        til := getTile( xx, yy );
        FStream.WriteBuffer( alt, 1 );
        FStream.WriteBuffer( til, 1 );
      end;

    FStream.free;
  end
  else
    showmessage( 'Map not initialized' );
end;

procedure TMap.DoPlane;
begin
  if RawData <> nil then FreeMem( RawData );
  GetMem( RawData, Width * Height * 2 );

  CustomFill( 0, 0, Width - 1, Height - 1, 1 );
end;

procedure TMap.CustomFill( x1, y1, x2, y2, al : integer );
var
  xx, yy, k, t1, t2, t3, t4, t5, t6, t7, t8, p1, p2, p3, p4, p5, p6, p7, p8 : integer;
  alt, til : byte;

begin
{  PlaneForm.editAlt.text := inttostr( al );
  PlaneForm.ShowModal;
  with PlaneForm do
  begin
    k := strtoint( editAlt.text );
    if k < 0 then
    begin
      exit;
    end;
    alt := k mod 256;
    t1 := strtoint( EditId1.text );
    t2 := strtoint( EditId2.text );
    t3 := strtoint( EditId3.text );
    t4 := strtoint( EditId4.text );
    t5 := strtoint( EditId5.text );
    t6 := strtoint( EditId6.text );
    t7 := strtoint( EditId7.text );
    t8 := strtoint( EditId8.text );
    p1 := strtoint( EditSurf1.text );
    p2 := strtoint( EditSurf2.text );
    p3 := strtoint( EditSurf3.text );
    p4 := strtoint( EditSurf4.text );
    p5 := strtoint( EditSurf5.text );
    p6 := strtoint( EditSurf6.text );
    p7 := strtoint( EditSurf7.text );
    p8 := strtoint( EditSurf8.text );
    randomize;

    for xx := x1 to x2 do
      for yy := y1 to y2 do
      begin
        k := random( 100 );
        if k < p1 then
          til := t1
        else if k < ( p1 + p2 ) then
          til := t2
        else if k < ( p1 + p2 + p3 ) then
          til := t3
        else if k < ( p1 + p2 + p3 + p4 ) then
          til := t4
        else if k < ( p1 + p2 + p3 + p4 + p5 ) then
          til := t5
        else if k < ( p1 + p2 + p3 + p4 + p5 + p6 ) then
          til := t6
        else if k < ( p1 + p2 + p3 + p4 + p5 + p6 + p7 ) then
          til := t7
        else
          til := t8;
        SetAltitude( xx, yy, alt );
        SetTile( xx, yy, til );
      end;

  end; //with
 }

end;

constructor TTerrain.Create;
begin
  inherited Create;
  NameImage := 'NoImage';
  Number := 0;
  Bmp := TBitmap.Create;
  Tiles := Tlist.Create;
end;

destructor TTerrain.Destroy;
var
  k : integer;
  at : TTile;

begin
  Bmp.free;
  for k := 0 to Number - 1 do
  begin
    at := Tiles[ k ];
    at.free;
  end;
  Tiles.free;
  inherited Destroy;
end;

procedure TTerrain.LoadFromFile( sFileName : string );
var
  atile, sl, p : integer;
  S, CPath : string;
  NewTile : TTile;
  TL : TStringList;
begin
  if sFileName <> '' then
  begin
    TL := TStringList.Create;
    TL.LoadFromFile( sFilename );
    CPath     := ExtractFilePath( sFilename );
    Filename  := sFileName;
    NameImage := TL[ 0 ];
    Bmp.LoadFromFile( CPath + NameImage );
    Surface := TDirectDrawSurface.Create( DX_Draw.DDraw );
    Surface.LoadFromFile( CPath + NameImage );
    Surface.TransparentColor := clWhite;
    Number := strtoint( TL[ 1 ] );
    StndWidth := strtoint( TL[ 2 ] );
    StndHeight := strtoint( TL[ 3 ] );
    LevelShift := strtoint( TL[ 4 ] );

    if Number > 0 then
    begin
      for atile := 0 to Number - 1 do
      begin
        NewTile := TTile.Create;
        NewTile.ID := atile;
        sl := TL.indexof( 'ID=' + inttostr( atile ) );

        S := TL[ sl + 1 ];
        p := Pos( '=', S );
        NewTile.Name := copy( S, p + 1, length( S ) - p );

        S := TL[ sl + 2 ];
        p := Pos( '=', S );
        NewTile.OriginX := strtoint( copy( S, p + 1, length( S ) - p ) );

        S := TL[ sl + 3 ];
        p := Pos( '=', S );
        NewTile.OriginY := strtoint( copy( S, p + 1, length( S ) - p ) );

        S := TL[ sl + 4 ];
        p := Pos( '=', S );
        NewTile.Width := strtoint( copy( S, p + 1, length( S ) - p ) );

        S := TL[ sl + 5 ];
        p := Pos( '=', S );
        NewTile.Height := strtoint( copy( S, p + 1, length( S ) - p ) );

        S := TL[ sl + 6 ];
        p := Pos( '=', S );
        NewTile.ShiftY := strtoint( copy( S, p + 1, length( S ) - p ) );

        S := TL[ sl + 7 ];
        p := Pos( '=', S );
        NewTile.TileType := strtoint( copy( S, p + 1, length( S ) - p ) ) mod 256;

        S := TL[ sl + 8 ];
        p := Pos( '=', S );
        NewTile.IDPlane := strtoint( copy( S, p + 1, length( S ) - p ) );

        Tiles.add( NewTile );
      //NewTile.free;
      end;
    end;
    TL.free;
  end;

end;

{
================================================================================
}

constructor TSprites.Create;
begin
  FSpriteDataList := TList.Create;
  FSpriteList     := TList.Create;
end;


destructor TSprites.Destroy;
var
  k,j : integer;
begin
  // Sprite Data
  for k := 0 to FSpriteDataList.Count - 1 do
  begin
    {for j := 0 to MAX_FRAMES -1 do
    begin
       if TSpriteData( FSpriteDataList[ k ] ).FFrames[j].Bitmap <> nil then
            TSpriteData( FSpriteDataList[ k ] ).FFrames[j].Bitmap.Free;
       if TSpriteData( FSpriteDataList[ k ] ).FFrames[j].Surface <> nil then
            TSpriteData( FSpriteDataList[ k ] ).FFrames[j].Surface.Free;
    end;}
    TSpriteData( FSpriteDataList[ k ] ).free;
  end;
  FSpriteDataList.Free;
  // Sprite Info
  for k := 0 to FSpriteList.Count - 1 do
    TSprite( FSpriteList[ k ] ).free;
  FSpriteList.Free;
end;


procedure TSprites.LoadFromFile( FileName : string );
var
  k, j, cutPoint : integer;
  sl : TStringList;
  tmpStr, sep, currLine : string;
  tmpSprite : TSprite;
  tmpSpriteData : TSpriteData;
  tmpCoord : TPoint;
begin
  sl := TStringList.Create;
  sl.LoadFromFile( FileName );
  sep := ','; //Ub separatore di campi

  for k := 0 to sl.Count - 1 do
  begin
  //		tracestring('Line n.'+inttostr(k));
    currLine := sl[ k ];
    cutPoint := pos( sep, currLine );
    tmpStr := copy( currLine, 1, cutPoint - 1 ); //prima c'e' il FileName
  //		tracestring('Try to load '+TmpStr);
    tmpSpriteData := LoadSpriteData( tmpStr );
  //		tracestring('Try to create '+TmpStr);
    tmpSprite := TSprite.Create( tmpSpriteData );
    currLine := copy( currLine, cutPoint + 1, length( currLine ) );
    cutPoint := pos( sep, currLine );

    tmpStr := copy( currLine, 1, cutPoint - 1 ); //ignora il NomeSprite
    tmpSprite.Name := tmpStr;
    currLine := copy( currLine, cutPoint + 1, length( currLine ) );

    cutPoint := pos( sep, currLine );
    tmpStr := copy( currLine, 1, cutPoint - 1 ); //poi c'e' l'energia
    currLine := copy( currLine, cutPoint + 1, length( currLine ) );
    //tmpSprite.FEnergy := strtoint( tmpStr );

    cutPoint := pos( sep, currLine );
    tmpStr := copy( currLine, 1, cutPoint - 1 ); //poi c'e' la coord X
    currLine := copy( currLine, cutPoint + 1, length( currLine ) );
    tmpSprite.X := strtoint( tmpStr );

    cutPoint := pos( sep, currLine );
    tmpStr := copy( currLine, 1, cutPoint - 1 ); //poi c'e' la coord Y
    currLine := copy( currLine, cutPoint + 1, length( currLine ) );
    tmpSprite.Y := strtoint( tmpStr );
  //		tracestring('Sprite set');

    {tmpCoord.x := trunc( tmpCoord.x / 100 * FPlayField.TileSizeMap );
    tmpCoord.y := trunc( tmpCoord.y / 100 * FPlayField.TileSizeMap );}

    cutPoint := pos( sep, currLine );
    tmpStr := copy( currLine, 1, cutPoint - 1 ); //poi c'e' la coord Base X
    currLine := copy( currLine, cutPoint + 1, length( currLine ) );
    tmpSprite.BaseX := strtoint( tmpStr );
    tmpSprite.BaseY := strtoint( currLine );  // last point


    {if tmpDDSpriteData.Kind = knCharacter then
    begin
      if tmpSprite.Name = 'XXXXXX' then
      begin
        FPlayer0List.Add( tmpSprite );
        tmpSprite.NPlayer := 0;
      end
      else
      begin
        FPlayer1List.Add( tmpSprite );
        tmpSprite.NPlayer := 1;
      end;
    //tracestring(inttostr(tmpSprite.NPlayer));
    end
    else
    begin
      FAmbientList.Add( tmpSprite );
    end;
    tmpSprite.AllSprites := self;
    FZOrderList.Add( tmpSprite );}
    //Tracestring('Line ended');
    FSpriteList.Add( tmpSprite );
  end;
  sl.free;

end;


function TSprites.LoadSpriteData( SpriteFile : string ) : TSpriteData;
var
  k : integer;
begin
  if FSpriteDataList.Count > 0 then
    for k := 0 to FSpriteDataList.Count - 1 do
    begin
      if compareText( TSpriteData( FSpriteDataList[ k ] ).FileName, SpriteFile ) = 0 then //se lo trova gia' nella lista
      begin
        result := TSpriteData( FSpriteDataList[ k ] ); //restituisce il puntatore
        exit;
      end;
    end;
  FSpriteDataList.Add( TSpriteData.Create( SpriteFile ) ); //lo crea
  result := TSpriteData( FSpriteDataList[ FSpriteDataList.Count - 1 ] );
end;


procedure TSprites.SaveToFile( FileName : string );
var
  SL : TStringList;
  k : integer;
begin
  SL := TStringList.Create;
  for K := 0 to FSpriteList.Count - 1 do
  begin
     with TSprite( FSpriteList[K] ) do
     SL.Add( FSpriteData.FileName + ','+ Name + ',0,' + inttostr(X) + ',' + inttostr(Y) + ',' +
             inttostr(BaseX) + ',' + inttostr(BaseY) );
  end;
  SL.SaveToFile( Filename );
  SL.Free;
end;

{*******************************************************************************
  S P R I T E
}
constructor TSprite.Create( SpriteData : TSpriteData );
begin
  FSpriteData := SpriteData;
  X := 0; Y := 0;
  BaseX:= 0; BaseY:= 0;
end;

constructor TSprite.Create( SpriteFile : string );
begin
  FSpriteData := TSpriteData.Create( SpriteFile );
  X := 0; Y := 0;
  BaseX := 0; BaseY := 0;
end;

procedure TSprite.Draw;
begin
  DX_Draw.Surface.Draw(X-BaseX, Y-BaseY, FSpriteData.FFrames[0].FRect, FSpriteData.FFrames[0].Surface, True);
end;

{*******************************************************************************
  S P R I T E   -  D A T A
}

{ Create the data sprite
}
constructor TSpriteData.Create( SpriteFile : string );
var
  sl : TStringList; //file *.spr
  LastFrame, LastAnimation, LastRow, FramesCount : Integer;
  F, L, T, H, W, BX, BY, D, FX : Integer;
  tmpStr, ra : string;
  TempSurface : TDirectDrawSurface; //TDDSurface; //
  TempBitmap  : TBitmap;
  SpritePath : string;
begin
 try
  FileName := SpriteFile;
  if uppercase(ExtractFileExt( FileName )) = '.SPR' then
  begin
      LastRow := 0;
      sl := TStringList.Create;
      sl.LoadFromFile( SpriteFile );
      FileName   := SpriteFile;
      SpritePath := ExtractFilePath( SpriteFile ); //Ub serve per tirar su i bmp
      Name := sl.Values[ 'Name' ];

      FramesCount := StrToInt( sl.Values[ 'NF' ] ); //qui andrebbe dimensionato l'array frames
      LastFrame   := -1;
      LastAnimation := -1;
      LastRow     := sl.IndexOf( 'NF=' + IntToStr( FramesCount ) ) + 1; // LastRow
      TempSurface := nil;
      TempBitmap  := nil;
      while LastRow < sl.count do //passa le righe una a una
      begin
        ra := sl[ LastRow ];
        if copy( ra, 1, 9 ) = 'Animation' then
        begin
          inc( LastAnimation );
          {FAnimations[ LastAnimation ].Start := LastFrame + 1;
          FAnimations[ LastAnimation ].Length := 0;}
        end
        else
          if copy( ra, 1, 9 ) = 'ImageFile' then
          begin
            TempBitmap  := TBitmap.Create;
            TempBitmap.LoadFromFile( SpritePath + copy( ra, 11, length( ra ) ) );
            TempSurface := TDirectDrawSurface.Create( DX_Draw.DDraw );
            TempSurface.LoadFromFile( SpritePath + copy( ra, 11, length( ra ) ) );
            TempSurface.TransparentColor := clWhite;

            {TempSurface.SetBmpColorKey( 255 );}
            //TempSurface.
          end
          else
          if copy( ra, 1, 2 ) = 'ID' then
          begin
            if StrToInt( copy( ra, 4, length( ra ) ) ) <> LastFrame + 1 then
               ShowMessage( 'Invalid Frame ID (' + ra + ')' );
           //FAnimations[ LastAnimation ].Length := FAnimations[ LastAnimation ].Length + 1;

            inc( LastFrame );
            inc( LastRow );
            ra := sl[ LastRow ];
            L := StrToInt( copy( ra, 4, length( ra ) ) );
            inc( LastRow );
            ra := sl[ LastRow ];
            T := StrToInt( copy( ra, 4, length( ra ) ) );
            inc( LastRow );
            ra := sl[ LastRow ];
            W := StrToInt( copy( ra, 3, length( ra ) ) );
            inc( LastRow );
            ra := sl[ LastRow ];
            H := StrToInt( copy( ra, 3, length( ra ) ) );
            inc( LastRow );
            ra := sl[ LastRow ];
            BX := StrToInt( copy( ra, 4, length( ra ) ) );
            inc( LastRow );
            ra := sl[ LastRow ];
            BY := StrToInt( copy( ra, 4, length( ra ) ) );
            inc( LastRow );
            ra := sl[ LastRow ];
            D := StrToInt( copy( ra, 3, length( ra ) ) ); //Durata frame in s/100
            //  D := D * 10 div Delay; //Durata in Flip
            inc( LastRow );
            ra := sl[ LastRow ];
            if copy( ra, 1, 3 ) = 'FX=' then //lo legge solo se c'e'
               FX := StrToInt( copy( ra, 4, length( ra ) ) )
             else
               FX := 0;
            FFrames[ LastFrame ].FRect := Rect( L, T, L + W, T + H );
            FFrames[ LastFrame ].BaseOffset.X := BX;
            FFrames[ LastFrame ].BaseOffset.Y := BY;
            FFrames[ LastFrame ].Surface      := TempSurface;
            FFrames[ LastFrame ].Bitmap       := TempBitmap;
            FFrames[ LastFrame ].Duration     := D;
            FFrames[ LastFrame ].Effects      := FX; // Ufff!!, ???=?=?=?
         end;
         inc( LastRow );
       end;
       sl.free;
    end
    else
    begin
      // direct Bitmap especification
      TempBitmap  := TBitmap.Create;
      TempBitmap.LoadFromFile( FileName );
      TempSurface := TDirectDrawSurface.Create( DX_Draw.DDraw );
      TempSurface.LoadFromFile( FileName );
      TempSurface.TransparentColor := clWhite;
      FFrames[ 0 ].FRect := Rect( 0, 0, TempBitMap.Width, TempBitMap.Height );
      FFrames[ 0 ].BaseOffset.X := 0;
      FFrames[ 0 ].BaseOffset.Y := 0;
      FFrames[ 0 ].Surface      := TempSurface;
      FFrames[ 0 ].Bitmap       := TempBitmap;
      FFrames[ 0 ].Duration     := 0;
      FFrames[ 0 ].Effects      := 0;
    end;

  finally
    {if LastRow <> sl.Count then
    begin
      ShowMessage( 'Error in ' + SpriteFile + '  ' + inttostr( LastRow ) + '/' + inttostr( sl.count ) );
    end;
    sl.free;}
  end; //try..finally
end;

procedure TSpriteData.Draw(Frame, X, Y : integer );
begin
   // Draw Directly to the surface at the position stated
   DX_Draw.Surface.Draw(X, Y, FFrames[Frame].FRect, FFrames[Frame].Surface, True);
end;


end.
